-- --------------------------------------------------------------------
-- @author: 幸运探宝
-- --------------------------------------------------------------------
ActionTreasureWindow = ActionTreasureWindow or BaseClass(BaseView)

local gw_role_vo = RoleController:getInstance():getRoleVo()
local controller = ActionController:getInstance()
local model = controller:getModel()
local string_format = string.format
local treasure_const = Config.DialData.data_const
local rand_list = Config.DialData.data_get_rand_list
local ROUND_COUNT = 8
--local reward_pos = {{5,204},{119,155},{166,40},{117,-74},{1,-120},{-114,-73},{-161,43},{-111,157}}
local reward_pos = {{3,222},{130,162},{180,40},{128,-84},{3,-140},{-122,-84},{-174,41},{-126,161}}
local lucky_bar_reward_pos = {{71,200-102},{71,308-102},{71,416-102},{71,524-102},{71,632-102}}
local run_light_pos = {{5,204,0},{119,155,45},{166,40,90},{117,-74,135},{1,-120,180},{-114,-73,225},{-161,43,270},{-111,157,315}}
--数字的转换  从0开始
local change_pos = {
    [0] = 1,
    [1] = 2,
    [2] = 3,
    [3] = 4,
    [4] = 5,
    [5] = 6,
    [6] = 7,
    [7] = 8,
    [8] = 1, --越界处理
}

function ActionTreasureWindow:__init()
    self.firstComein = true
    self.is_full_screen = true
    self.touchEnable = false --防止乱点，必须等到本地抽奖完成之后才能进行下一次
    self.touchRefresh = false
    self.tab_list = {}
    self.reward_lucky = {}
    self.treasureCount = 1
    self.cur_index = nil
    self.cur_effect_index = nil --用于播放音效的

    self.desc_item_name = {}
    self.desc_item_Lv = {}

    --拥有的劵数
    self.hasTreasure_num = {}
    --点击的探宝类型  -- 1  2
    self.touchTreasure_type = 1
    --查看更多里面的个数
    self.checkMoreCount = 1
    --标签页红点
    -- self.tabRedPoint = {false,false}
    --点击刷新控制特效
    self.touchEffect = {true,true}
    --探宝记录
    self.getRewardList = {}
    --幸运值达到领取奖励数字
    self.arriveLuckly_label = {}

    self.round_certer_load = {}
    self.item_list = {}
    --self.luckly_item = {}
    self.gw_luckly_item = {}
    self.win_type = WinType.Full 
    self.layout_name = "action/gw_action_treasure_window"
    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_action","gw_action_treasure"), type = ResourcesType.plist },
        { path = PathTool.getPlistImgForDownLoad("gw_seerpalace","gw_seerpalace"), type = ResourcesType.plist },
        --{ path = PathTool.getPlistImgForDownLoad("gw_action_treasure","gw_action_treasure_background", true), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_action_treasure","gw_action_treasure_round_1", false), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_action_treasure","gw_action_treasure_round_2", false), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_action_treasure","gw_action_treasure_run_light", false), type = ResourcesType.single },
    }
end

function ActionTreasureWindow:open_callback()
    self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    self.left_top_container:setPositionX(display.getLeft())
    self.left_top_container:setPositionY(display.getTop())
    self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    self.right_top_container:setPositionX(display.getRight())
    self.right_top_container:setPositionY(display.getTop())
    self.bottom_container = self.root_wnd:getChildByName("bottom_container")
    self.bottom_container:setPositionY(display.getBottom())
    self.sheet_node = self.bottom_container:getChildByName("sheet_node")
    self.sheet_node:setPositionX(display.getRight())
    self.bottom_bg = self.bottom_container:getChildByName("bg")
    self.bottom_bg:setContentSize(cc.size(display.width, 120))

    --返回上一级
    self.back_btn = self.left_top_container:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            if self.touchEnable == true then return end
            playButtonSound2()
            controller:openLuckyTreasureWin(false)
        end
    end)
    --返回主城
    self.home_btn = self.right_top_container:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            if self.touchEnable == true then return end
            BackToHome()
        end
    end)

    self.tips_btn = self.left_top_container:getChildByName("tips_btn")
    self.tips_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            if self.touchEnable == true then return end
            local config = Config.DialData.data_const.game_rule1
            if self.cur_index == 2 then
                config = Config.DialData.data_const.game_rule2
            end
            TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition())
        end
    end)
    self.check_btn = self.left_top_container:getChildByName("check_btn")
    self.check_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            if self.touchEnable == true then return end
            self:rewardProbility(self.cur_index)
        end
    end)
    self.shop_btn = self.right_top_container:getChildByName("shop_btn")
    self.shop_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            if self.touchEnable == true then return end
            StrongerController:getInstance():clickCallBack(406)
        end
    end)
    self.shop_btn_label = self.shop_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.shop_btn_label, UI_TI18N(25001), 116)

    --上方资产
    self.top_num_wealth_list = {}
    for i=1,3 do
        self.top_num_wealth_list[i] = {}
        if i==1 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
        elseif i==2 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
        else
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
        end
        self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
        self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")
    end
    self.coin_redpoint = self.top_num_wealth_list[2].btn:getChildByName("add")

    --页签
    local text_title = {UI_TI18N(25002),UI_TI18N(25003)}
    self.sheet_btn_list = {}
    for i=1,2 do
        self.sheet_btn_list[i] = self.sheet_node:getChildByName("sheet_btn"..i)
        self.sheet_btn_list[i].normal = self.sheet_btn_list[i]:getChildByName("normal")
        self.sheet_btn_list[i].select = self.sheet_btn_list[i]:getChildByName("select")
        local str = text_title[i]
        self.sheet_btn_list[i].normal:getChildByName("label"):setString(str)
        self.sheet_btn_list[i].select:getChildByName("label"):setString(str)
        self.sheet_btn_list[i].red_point = self.sheet_node:getChildByName("red_point"..i)
        self.sheet_btn_list[i]:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                if self.touchEnable == true then return end
                playButtonSound2()
                self:onClickSheetBtn(i)
            end
        end)
    end
    local spine_node = self.sheet_btn_list[1].select:getChildByName("spine_node")
    function onSheetBtn1SpineCallBack()
        if self.sheet_btn_list[1].spine_flag == true then
            self.sheet_btn_list[1].spine_flag = false
            self.sheet_btn_list[1].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[1].spine_flag = false
    self.sheet_btn_list[1].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn1SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[1].spine)
    local spine_node = self.sheet_btn_list[2].select:getChildByName("spine_node")
    function onSheetBtn2SpineCallBack()
        if self.sheet_btn_list[2].spine_flag == true then
            self.sheet_btn_list[2].spine_flag = false
            self.sheet_btn_list[2].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[2].spine_flag = false
    self.sheet_btn_list[2].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn2SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[2].spine)

    self.main_container = self.root_wnd:getChildByName("main_container")
    self.main_container:setPositionY(display.getBottom())

    --幸运值相关信息
    self.lucky_info = self.main_container:getChildByName("lucky_info")
    self.lucky_info:setVisible(false)
    self.lucky_info:setPositionX(display.getLeft())
    self.lucky_info_bar = self.lucky_info:getChildByName("bar")
    self.lucky_info_bar:setScale9Enabled(true)
    self.lucky_info_bar_tab = self.lucky_info:getChildByName("bar_tab")
    self.lucky_info_value_bg = self.lucky_info:getChildByName("value_bg")
    self.lucky_info_value_label1 = self.lucky_info:getChildByName("value_label1")
    self.lucky_info_value_label2 = self.lucky_info:getChildByName("value_label2")
    self.lucky_info:getChildByName("tips_label"):setString(UI_TI18N(25004))
    self.lucky_info_reward_list = {}
    for i=1,5 do
        self.lucky_info_reward_list[i] = self.lucky_info:getChildByName("reward"..i)
        self.lucky_info_reward_list[i].num = self.lucky_info_reward_list[i]:getChildByName("num")
        self.lucky_info_reward_list[i].item1_node = self.lucky_info_reward_list[i]:getChildByName("item1_node")
        self.lucky_info_reward_list[i].item2_node = self.lucky_info_reward_list[i]:getChildByName("item2_node")
        self.lucky_info_reward_list[i].redpoint = self.lucky_info_reward_list[i]:getChildByName("redpoint")
        self.lucky_info_reward_list[i].btn = self.lucky_info_reward_list[i]:getChildByName("btn")
        self.lucky_info_reward_list[i].btn:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                if self.cur_index == nil then return end
                if self.touchEnable == true then return end
                local luckly_num_data = model:getLucklyRewardData(self.cur_index)
                controller:send16640(self.cur_index, luckly_num_data[i].id)
            end
        end)
        self.lucky_info_reward_list[i]:setVisible(false)
    end

    self.btn_treasure_1 = self.main_container:getChildByName("btn_treasure_1")
    self.btn_treasure_1:setVisible(false)
    self.btn_treasure_1:addTouchEventListener(function(sender, event_type)
        if self.touchEnable ~= true then
            customClickAction_4(sender, event_type)
        end
        if event_type == ccui.TouchEventType.ended then
            if self.cur_index == nil then return end
            if self.touchEnable == true then return end
            self:sendTreasureLottery(1)
        end
    end)
    self.btn_treasure_1_label = self.btn_treasure_1:getChildByName("label")
    self.treasure_1_consume = self.main_container:getChildByName("treasure_1_consume")
    self.treasure_1_consume:setVisible(false)
    self.treasure_1_consume_label = self.treasure_1_consume:getChildByName("label")
    self.treasure_1_consume_label:setString(UI_TI18N(25005))
    self.treasure_1_consume_icon = self.treasure_1_consume:getChildByName("icon")
    self.treasure_1_consume_num = self.treasure_1_consume:getChildByName("num")
    self.btn_treasure_2 = self.main_container:getChildByName("btn_treasure_2")
    self.btn_treasure_2:setVisible(false)
    self.btn_treasure_2:addTouchEventListener(function(sender, event_type)
        if self.touchEnable ~= true then
            customClickAction_4(sender, event_type)
        end
        if event_type == ccui.TouchEventType.ended then
            if self.cur_index == nil then return end
            if self.touchEnable == true then return end
            self:sendTreasureLottery(2)
        end
    end)
    self.btn_treasure_2_label = self.btn_treasure_2:getChildByName("label")
    self.treasure_2_consume = self.main_container:getChildByName("treasure_2_consume")
    self.treasure_2_consume:setVisible(false)
    self.treasure_2_consume_label = self.treasure_2_consume:getChildByName("label")
    self.treasure_2_consume_label:setString(UI_TI18N(25005))
    self.treasure_2_consume_icon = self.treasure_2_consume:getChildByName("icon")
    self.treasure_2_consume_num = self.treasure_2_consume:getChildByName("num")

    local refresh_time_node = self.main_container:getChildByName("refresh_time_node")
    self.refresh_time_label = createRichLabel(24, cc.c4b(0xbc,0xbc,0xbc,0xff), cc.p(0,0.5), cc.p(0,0), nil, nil, 360)
    refresh_time_node:addChild(self.refresh_time_label)
    self.refresh_btn = self.main_container:getChildByName("refresh_btn")
    self.refresh_btn:setVisible(false)
    self.refresh_btn:addTouchEventListener(function(sender, event_type)
        if self.touchEnable ~= true then
            customClickAction_4(sender, event_type)
        end
        if event_type == ccui.TouchEventType.ended then
            if self.cur_index == nil then return end
            if self.touchEnable == true then return end
            self:sendTreasureLottery(3)
        end
    end)
    self.refresh_btn_free = self.refresh_btn:getChildByName("free")
    self.refresh_btn_free_label1 = self.refresh_btn_free:getChildByName("label1")
    self.refresh_btn_free_label1:setString(UI_TI18N(25006))
    self.refresh_btn_free_label2 = self.refresh_btn_free:getChildByName("label2")
    self.refresh_btn_free_label2:setString(UI_TI18N(25007))
    self.refresh_btn_cost = self.refresh_btn:getChildByName("cost")
    self.refresh_btn_cost_icon = self.refresh_btn_cost:getChildByName("icon")
    self.refresh_btn_cost_label = self.refresh_btn_cost:getChildByName("label")

    self.item_infos = self.main_container:getChildByName("item_infos")
    self.item_infos_round = self.item_infos:getChildByName("round")
    self.run_light = self.item_infos:getChildByName("run_light")
    self.run_light:setVisible(false)
    self.item_infos_items_node = self.item_infos:getChildByName("items_node")

    self.text_scroll = self.main_container:getChildByName("text_scroll")
    self.text_scroll:setScrollBarEnabled(false)

    self.status_count = 0

    model:setLucklyRewardData()
    model:setBuyRewardData()

    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    --local bg_res = PathTool.getPlistImgForDownLoad("gw_action_treasure", "gw_action_treasure_background", true)
    --if not self.background_load then
    --    self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    --end

	--local main_container = self.root_wnd:getChildByName("main_container")
    --self.main_container = main_container
    --self:playEnterAnimatianByObj(self.main_container, 1)
    --
    --self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    --self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    --
    ----返回上一级
    --self.back_btn = self.left_top_container:getChildByName("back_btn")
    --self.back_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        controller:openLuckyTreasureWin(false)
    --    end
    --end)
    ----返回主城
    --self.home_btn = self.right_top_container:getChildByName("home_btn")
    --self.home_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        BackToHome()
    --    end
    --end)
    --
    ----金币信息
    --self.right_top_container_gold_info = self.right_top_container:getChildByName("gold_info")
    --self.right_top_container_gold_info_value = self.right_top_container_gold_info:getChildByName("value")
    --self.right_top_container_gold_info_redpoint = self.right_top_container_gold_info:getChildByName("add")
    --self.right_top_container_gold_info:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        ExchangeController:getInstance():openExchangeMainView(true)
    --    end
    --end)
    ----钻石信息
    --self.right_top_container_diamond_info = self.right_top_container:getChildByName("diamond_info")
    --self.right_top_container_diamond_info_value = self.right_top_container_diamond_info:getChildByName("value")
    --self.right_top_container_diamond_info:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
    --    end
    --end)
    ----探宝券信息
    --self.right_top_container_treasure_info = self.right_top_container:getChildByName("treasure_info")
    --self.right_top_container_treasure_info_icon = self.right_top_container_treasure_info:getChildByName("icon")
    --self.right_top_container_treasure_info_value = self.right_top_container_treasure_info:getChildByName("value")
    --self.right_top_container_treasure_info:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        if self.cur_index then
    --            local buy_reward_data = model:getBuyRewardData(self.cur_index)
    --
    --            local lottery_id = buy_reward_data[1].expend_item[1][1]
    --            local item_config = Config.ItemData.data_get_data(lottery_id)
    --            if item_config then
    --                BackpackController:getInstance():openTipsSource(true,item_config)
    --            end
    --        end
    --    end
    --end)
    --
    --
    --
    --self.text_scroll = main_container:getChildByName("text_scroll")
    --self.text_scroll:setScrollBarEnabled(false)
    --self.probablity = main_container:getChildByName("probablity")
    --self.probablity:setVisible(false)
    --
    --self.item_panel = main_container:getChildByName("item_panel")
    --self.round_certer = self.item_panel:getChildByName("round")
    --self.items_node = self.item_panel:getChildByName("items_node")
    --
    --self.getted_info_bg = main_container:getChildByName("getted_info_bg")
    --self.btnLockOther = self.getted_info_bg:getChildByName("btnLockOther")
    --self.btnLockOther:getChildByName("Text_4"):setString(TI18N("查看"))
    --
    --main_container:getChildByName("refresh_time_label"):setString(TI18N("后刷新"))
    --self.refresh_time = main_container:getChildByName("refresh_time")
    --self.refresh_time:setString("00:00:00")
    --
    --self.run_light_node = self.item_panel:getChildByName("run_light_node")
    --self.run_light = self.run_light_node:getChildByName("run_light")
    --self.run_light:setVisible(false)
    --
    --self.status_count = 0
    --
    --model:setLucklyRewardData()
    --model:setBuyRewardData()
    --
    --self.lucky_bar = main_container:getChildByName("lucky_bar")
    --self.lucky_bar:setScale9Enabled(true)
    --self.lucky_bar_reward_node = main_container:getChildByName("lucky_bar_reward_node")
    --self.lucky_bar_tab = main_container:getChildByName("lucky_bar_tab")
    --
    --local tab_container = main_container:getChildByName("tab_container")
    --local text_title = {TI18N("幸运探宝"),TI18N("高级探宝")}
    --for i=1, 2 do
    --    local tab_btn = tab_container:getChildByName(string.format("tab_btn_%s",i))
    --    tab_btn.normal_img = tab_btn:getChildByName("normal_img")
    --    tab_btn.normal_label = tab_btn:getChildByName("normal_label")
    --    tab_btn.select_img = tab_btn:getChildByName("select_img")
    --    tab_btn.select_label = tab_btn:getChildByName("select_label")
    --    tab_btn.select_img:setVisible(false)
    --    tab_btn.select_label:setVisible(false)
    --    tab_btn.normal_label:setString(text_title[i])
    --    tab_btn.select_label:setString(text_title[i])
    --    tab_btn.redpoint = tab_btn:getChildByName("redpoint")
    --    tab_btn.redpoint:setVisible(false)
    --    tab_btn.index = i
    --    self.tab_list[i] = tab_btn
    --end
    --
    --for i=1,2 do
    --    local buy_reward_data = model:getBuyRewardData(i)
    --    local lottery_id = buy_reward_data[1].expend_item[1][1]
    --    self.hasTreasure_num[i] = BackpackController:getInstance():getModel():getBackPackItemNumByBid(lottery_id)
    --end
    --
    --self.btnTreasure = {}
    --for i=1,2 do
    --    local tab = {}
    --    tab.btn = main_container:getChildByName("btn_treasure_"..i)
    --    tab.consume_bg = tab.btn:getChildByName("consume_bg")
    --    tab.consume_bg_icon = tab.consume_bg:getChildByName("icon")
    --    tab.consume_bg_label = tab.consume_bg:getChildByName("label")
    --    tab.label = tab.btn:getChildByName("label")
    --    self.btnTreasure[i] = tab
    --end
    --
    --main_container:getChildByName("text_lucky_label"):setString(TI18N("幸运值"))
    --self.text_lucky_num = main_container:getChildByName("text_lucky_num")
    --self.text_lucky_num:setString("")
    --self.btnRule = main_container:getChildByName("btnRule")
    --self.btn_shop = main_container:getChildByName("btn_shop")
    --self.btn_shop:getChildByName("Text_1"):setString(TI18N("探宝商店"))
    --
    --self.refresh_btn = main_container:getChildByName("refresh_btn")
    --self.refresh_btn_free_icon = self.refresh_btn:getChildByName("free_icon")
    --self.refresh_btn_consume_icon = self.refresh_btn:getChildByName("consume_icon")
    --self.refresh_btn_label1 = self.refresh_btn:getChildByName("label1")
    --self.refresh_btn_label2 = self.refresh_btn:getChildByName("label2")
    --self.refresh_btn_label2:setString(TI18N("刷新"))

    --预加载音效
    AudioManager:getInstance():preLoadEffect(AudioManager.AUDIO_TYPE.COMMON, 'c_turntable_game')
    AudioManager:getInstance():preLoadEffect(AudioManager.AUDIO_TYPE.COMMON, 'c_turntable_game_1')
end

function ActionTreasureWindow:openRootWnd(index)
    ExchangeController:getInstance():send23606()
    --self.jump_index = index or 1
    --self:changeTabLocalData(self.jump_index)
    --controller:requestLucky()
    --

    self.cur_index = index or 1
    if self.cur_index == 2 then
        local role_ve = RoleController:getInstance():getRoleVo()
        local data = model:getBuyRewardData(2)
        if data and data[1].limit_open then
            if role_ve.lev < data[1].limit_open[1][2] then
                self.cur_index = 1
            end
        end
    end

    controller:requestLucky()
    self:setSheetTypeUI()
end
--倍率
function ActionTreasureWindow:rewardProbility(index)
    index = index or 1
    local config_data = {}
    local lev_index = 1
    local role_ve = RoleController:getInstance():getRoleVo()
    config_data = Config.DialData.data_magnificat_list[index]

    if config_data == nil then
        --self.probablity:setVisible(false)
        return
    end

    for i,v in ipairs(config_data) do
        if role_ve.lev >= v.min and role_ve.lev <= v.max then
            lev_index = i
            break
        end
    end
    local config = config_data[lev_index]

    SeerpalaceController:getInstance():openSeerpalacePreviewWindow(true, nil, 2, config.award )
    --for i=1, self.checkMoreCount do
    --    if self.desc_item_name[i] then
    --        self.desc_item_name[i]:setVisible(false)
    --    end
    --    if self.desc_item_Lv[i] then
    --        self.desc_item_Lv[i]:setVisible(false)
    --    end
    --end
    --self.checkMoreCount = tableLen(config.award)
    --
    --local num = math.floor(self.checkMoreCount/2)
    --self.probablity:setContentSize(cc.size(self.probablity:getContentSize().width, 45*num))
    --local pos_y = self.probablity:getContentSize().height - 35
    --
    --doStopAllActions(self.probablity)
    --for i=1, self.checkMoreCount do
    --    delayRun(self.probablity, i*2/60, function()
    --        if i <= num then
    --            local item_config = Config.ItemData.data_get_data(config.award[i][1])
    --            if not item_config then
    --                Debug.error("找不到道具配置，道具ID："..config.award[i][1])
    --            else
    --                if not self.desc_item_name[i] then
    --                    self.desc_item_name[i] = createLabel(26,cc.c4b(0x4c,0xd8,0x49,0xff),nil,0,0,"",self.probablity,nil, cc.p(0,0.5))
    --                end
    --                if self.desc_item_name[i] then
    --                    self.desc_item_name[i]:setVisible(true)
    --                    self.desc_item_name[i]:setContentSize(cc.size(150,30))
    --                    self.desc_item_name[i]:setString(TI18N(item_config.name))
    --                    self.desc_item_name[i]:setPosition(40,pos_y-36*(i-1))
    --                end
    --                if not self.desc_item_Lv[i] then
    --                    self.desc_item_Lv[i] = createLabel(26,cc.c4b(0xff,0xa7,0x2a,0xff),nil,0,0,"",self.probablity,nil, cc.p(0,0.5))
    --                end
    --                if self.desc_item_Lv[i] then
    --                    self.desc_item_Lv[i]:setVisible(true)
    --                    self.desc_item_Lv[i]:setString(config.award[i][2].."%")
    --                    self.desc_item_Lv[i]:setPosition(265,pos_y-36*(i-1))
    --                end
    --            end
    --        else
    --            local item_config = Config.ItemData.data_get_data(config.award[i][1])
    --            if not item_config then
    --                Debug.error("找不到道具配置，道具ID："..config.award[i][1])
    --            else
    --                if not self.desc_item_name[i] then
    --                    self.desc_item_name[i] = createLabel(26,cc.c4b(0x4c,0xd8,0x49,0xff),nil,0,0,"",self.probablity,nil, cc.p(0,0.5))
    --                end
    --                if self.desc_item_name[i] then
    --                    self.desc_item_name[i]:setVisible(true)
    --                    self.desc_item_name[i]:setContentSize(cc.size(150,30))
    --                    self.desc_item_name[i]:setString(TI18N(item_config.name))
    --                    self.desc_item_name[i]:setPosition(350,pos_y-36*(i-(num+1)))
    --                end
    --                if not self.desc_item_Lv[i] then
    --                    self.desc_item_Lv[i] = createLabel(26,cc.c4b(0xff,0xa7,0x2a,0xff),nil,0,0,"",self.probablity,nil, cc.p(0,0.5))
    --                end
    --                if self.desc_item_Lv[i] then
    --                    self.desc_item_Lv[i]:setVisible(true)
    --                    self.desc_item_Lv[i]:setString(config.award[i][2].."%")
    --                    self.desc_item_Lv[i]:setPosition(575,pos_y-36*(i-(num+1)))
    --                end
    --            end
    --        end
    --    end)
    --end
end

function ActionTreasureWindow:itemRewardPos(list)
    if not list or next(list) == nil then
        self.item_infos_items_node:setVisible(false)
        return
    end

    --以12点钟方向为起点，顺时针
    doStopAllActions(self.item_infos_items_node)
    for i=1, #list do
        delayRun(self.item_infos_items_node, i*2/60, function()
            if not self.item_list[i] then
                local item = GW_GoodsItem3.new(true,true, false, 0.72)
                item:setAnchorPoint(0.5, 0.5)
                self.item_infos_items_node:addChild(item)
                self.item_list[i] = item
            end
            if self.item_list[i] then
                self.item_list[i]:setPosition(reward_pos[i][1], reward_pos[i][2])
                self.item_list[i]:setBaseData(rand_list[list[i].id][1].item_id, rand_list[list[i].id][1].item_num)
                self.item_list[i]:setDefaultTip()

                if list[i] then
                    if list[i].status == 1 then
                        setChildUnEnabled(true, self.item_list[i])
                    elseif list[i].status == 0 then
                        setChildUnEnabled(false, self.item_list[i])
                    end
                end
                local fadein = cc.FadeIn:create(0.01)
                self.item_list[i]:runAction(fadein)
            end
        end)
    end
    self:runLightUniformSpeed()

    self.item_infos_items_node:setVisible(true)
end

----不需要服务端返回就可以显示的东西，避免UI出来时候有空挡
--function ActionTreasureWindow:changeTabLocalData(index)
--    if self.cur_index == index then return end
--
--    index = index or 1
--    local res = PathTool.getPlistImgForDownLoad("gw_action_treasure", "gw_action_treasure_round_"..index)
--    if not self.round_certer_load[index] then
--        self.round_certer_load[index] = loadSpriteTextureFromCDN(self.round_certer, res, ResourcesType.single, self.round_certer_load[index])
--    end
--    if self.round_certer_load[index] then
--        loadSpriteTexture(self.round_certer,res,LOADTEXT_TYPE)
--    end
--
--    local res = PathTool.getPlistImgForDownLoad("gw_action_treasure", "gw_action_treasure_run_light")
--    loadSpriteTexture(self.run_light,res,LOADTEXT_TYPE)
--
--
--    local buy_reward_data = model:getBuyRewardData(index)
--
--    local lottery_id = buy_reward_data[1].expend_item[1][1]
--    local item_config = Config.ItemData.data_get_data(lottery_id)
--    local res = PathTool.getItemRes(item_config.icon)
--    loadSpriteTexture(self.right_top_container_treasure_info_icon, res, LOADTEXT_TYPE)
--    self.right_top_container_treasure_info_value:setString(self.hasTreasure_num[index])
--
--    for i=1, 2 do
--        loadSpriteTexture(self.btnTreasure[i].consume_bg_icon, res, LOADTEXT_TYPE)
--        self.btnTreasure[i].label:setString(string_format(TI18N("探宝%d次"), treasure_const.treasure_num.val[index][i]))
--        self.btnTreasure[i].consume_bg_label:setString(buy_reward_data[i].expend_item[1][2])
--    end
--    self.refresh_btn_consume_icon:setVisible(false)
--    self.refresh_btn_free_icon:setVisible(true);
--    self.refresh_btn_label1:setString(TI18N("免费"))
--
--    local barBG = self.main_container:getChildByName("lucky_bar_bg")
--    local luckly_num_data = model:getLucklyRewardData(index)
--    local bar_interval = 552/5--barBG:getContentSize().width / 5
--
--    for i=1, 5 do
--        if not self.gw_luckly_item[i] then
--            self.gw_luckly_item[i] = {}
--            self.gw_luckly_item[i].label = createLabel(28,Config.ColorData.data_color4[1],nil,lucky_bar_reward_pos[i][1],lucky_bar_reward_pos[i][2],"",self.lucky_bar_reward_node,nil, cc.p(0,0.5))
--            self.gw_luckly_item[i].item_list = {}
--            for j=1,3 do
--                self.gw_luckly_item[i].item_list[j] = GW_BackPackItem.new(true,true, false, 0.45)
--                self.gw_luckly_item[i].item_list[j]:createSpriteRedPoint()
--                self.lucky_bar_reward_node:addChild(self.gw_luckly_item[i].item_list[j])
--                self.gw_luckly_item[i].item_list[j]:setPosition(cc.p(35 + lucky_bar_reward_pos[i][1] + 72*(j-1),lucky_bar_reward_pos[i][2]-45))
--            end
--        end
--
--        self.gw_luckly_item[i].label:setString(luckly_num_data[i].lucky_val)
--        for j=1,3 do
--            self.gw_luckly_item[i].item_list[j]:setVisible(false)
--        end
--        for j=1,#luckly_num_data[i].award do
--            if j <= 3 then
--                self.gw_luckly_item[i].item_list[j]:setBaseData(luckly_num_data[i].award[j][1], luckly_num_data[i].award[j][2])
--                self.gw_luckly_item[i].item_list[j]:setVisibleResPoint(false)
--                self.gw_luckly_item[i].item_list[j]:setVisible(true)
--                local function func()
--                    controller:send16640(index, luckly_num_data[i].id)
--                end
--                self.gw_luckly_item[i].item_list[j]:addCallBack(func)
--            else
--                break
--            end
--        end
--
--        --if not self.luckly_item[i] then
--        --    self.luckly_item[i] = RoundItem.new(true,0.55,0.7)
--        --    self.lucky_bar_reward_node:addChild(self.luckly_item[i])
--        --    self.luckly_item[i]:setPosition(cc.p(lucky_bar_reward_pos[i][1],lucky_bar_reward_pos[i][2]))
--        --end
--        --
--        --if not self.arriveLuckly_label[i] and self.luckly_item[i] then
--        --    self.arriveLuckly_label[i] = createLabel(28,Config.ColorData.data_color4[1],nil,65,-7,"",self.luckly_item[i],nil, cc.p(0.5,0.5))
--        --end
--        --if self.arriveLuckly_label[i] then
--        --    self.arriveLuckly_label[i]:setString(luckly_num_data[i].lucky_val)
--        --end
--        --if self.luckly_item[i] then
--        --    self.luckly_item[i]:setBaseData(luckly_num_data[i].award[1][1], luckly_num_data[i].award[1][2])
--        --    self.luckly_item[i]:setVisibleRedPoint(false)
--        --    self.luckly_item[i]:setVisibleRoundBG(false)
--        --    local function func()
--        --        controller:send16640(index, luckly_num_data[i].id)
--        --    end
--        --    self.luckly_item[i]:addCallBack(func)
--        --end
--    end
--end
--分段计算进度条
function ActionTreasureWindow:sectionCalculation(num,luckly_list)
    num = num or 10
    local segmeent = 20
    local percent = 1
    if luckly_list[1] and luckly_list[2] and luckly_list[3] and luckly_list[4] and luckly_list[5] then
        if num <= luckly_list[1].lucky_val then
            return num / luckly_list[1].lucky_val * (lucky_bar_reward_pos[1][2]/lucky_bar_reward_pos[5][2])*100
        elseif num > luckly_list[1].lucky_val and num <= luckly_list[2].lucky_val then
            --local adv = luckly_list[2].lucky_val - luckly_list[1].lucky_val
            --local count = num - luckly_list[1].lucky_val
            --local percent_num = lucky_bar_reward_pos[1][2]/lucky_bar_reward_pos[5][2] + ( count / adv ) * ((lucky_bar_reward_pos[2][2] - lucky_bar_reward_pos[1][2])/lucky_bar_reward_pos[5][2])
            --return percent_num
            percent = 2
        elseif num > luckly_list[2].lucky_val and num <= luckly_list[3].lucky_val then
            percent = 3
        elseif num > luckly_list[3].lucky_val and num <= luckly_list[4].lucky_val then
            percent = 4
        elseif num > luckly_list[4].lucky_val and num <= luckly_list[5].lucky_val then
            percent = 5
        else
            return 100
        end
        local adv = luckly_list[percent].lucky_val - luckly_list[percent-1].lucky_val
        local count = num - luckly_list[percent-1].lucky_val
        local pre_percent_num = lucky_bar_reward_pos[percent-1][2]/lucky_bar_reward_pos[5][2]
        local cur_percent_num = ( count / adv ) * ((lucky_bar_reward_pos[percent][2] - lucky_bar_reward_pos[percent-1][2])/lucky_bar_reward_pos[5][2])
        --Debug.info(pre_percent_num)
        --Debug.info(cur_percent_num)
        local percent_num = lucky_bar_reward_pos[percent-1][2]/lucky_bar_reward_pos[5][2] + ( count / adv ) * ((lucky_bar_reward_pos[percent][2] - lucky_bar_reward_pos[percent-1][2])/lucky_bar_reward_pos[5][2])
        return percent_num*100
        --local adv = luckly_list[percent].lucky_val - luckly_list[percent-1].lucky_val
        --local count = num - luckly_list[percent-1].lucky_val
        --local percent_num = segmeent*(percent - 1) + ( count / adv ) * segmeent
        --return percent_num
    else
        return 0
    end
end

--data:寻宝数据(服务端返回的)
function ActionTreasureWindow:commonShowData(data, luckly_list)
    if self.touchEnable == false then
        local initData = model:getTreasureInitData(self.cur_index)
        if initData then
            self:itemRewardPos(initData.rand_lists)
        else
            self.item_infos_items_node:setVisible(false)
        end
    end
    self:updateLuckyInfos(data, luckly_list)
    self:updateRefreshBtnStatus(data, luckly_list)

    --if not next(data) or not next(luckly_list) then return end
    --local lucky_num = 0
    --if luckly_list[5] then
    --    lucky_num = luckly_list[5].lucky_val
    --end
    --self.text_lucky_num:setString(data.lucky.."/"..lucky_num)
    --local mul = self:sectionCalculation(data.lucky, luckly_list)
    --self.lucky_bar:setPercent(mul)
    --self.lucky_bar_tab:setPositionY(93.5 + 544*mul/100)
    --
    --local refresh = data.end_time - GameNet:getInstance():getTime()
    --if refresh > 0 then
    --    model:setCountDownTime(self.refresh_time,refresh)
    --    local item_config = Config.ItemData.data_get_data(treasure_const.refreash.val[1][1])
    --    loadSpriteTexture(self.refresh_btn_consume_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
    --    self.refresh_btn_consume_icon:setVisible(true)
    --    self.refresh_btn_free_icon:setVisible(false);
    --    self.refresh_btn_label1:setString(treasure_const.refreash.val[1][2])
    --    self.touchEffect[data.type] = false
    --else
    --    self.refresh_btn_consume_icon:setVisible(false)
    --    self.refresh_btn_free_icon:setVisible(true);
    --    self.refresh_btn_label1:setString(TI18N("免费"))
    --    doStopAllActions(self.refresh_time)
    --    self.refresh_time:setString("00:00:00")
    --    self.touchEffect[data.type] = true
    --end
    --
    --local status = false
    --for i,v in pairs(luckly_list) do
    --    local _bool = true
    --    for k,m in pairs(data.lucky_award) do
    --        if v.id == m.lucky then
    --            _bool = false
    --            break
    --        end
    --    end
    --
    --    if data.lucky < v.lucky_val then
    --        _bool = false
    --    end
    --
    --    for j=1,3 do
    --        setChildUnEnabled(false, self.gw_luckly_item[i].item_list[j])
    --        if self.gw_luckly_item[i].item_list[j] then
    --            self.gw_luckly_item[i].item_list[j]:setDefaultTip(not _bool)
    --            status = status or _bool
    --            self.gw_luckly_item[i].item_list[j]:setVisibleResPoint(_bool)
    --
    --            if _bool == false and data.lucky >= v.lucky_val then
    --                setChildUnEnabled(true, self.gw_luckly_item[i].item_list[j])
    --            end
    --        end
    --    end
    --
    --    --setChildUnEnabled(false, self.luckly_item[i])
    --    --if self.luckly_item[i] then
    --    --    self.luckly_item[i]:setDefaultTip(not _bool)
    --    --    status = status or _bool
    --    --    self.luckly_item[i]:setVisibleRedPoint(_bool)
    --    --
    --    --    if _bool == false and data.lucky >= v.lucky_val then
    --    --        setChildUnEnabled(true, self.luckly_item[i])
    --    --    end
    --    --end
    --end
    --model:setLucklyTabRedPoint(data.type,status)
    --self:showRedpoint()
end

function ActionTreasureWindow:showRedpoint()
    local total_status = false
    for i,v in pairs(self.sheet_btn_list) do
        local status = model:getLucklyTabRedPoint(i)
        if status == true and v.red_point_spine == nil then
            v.red_point_spine = PathTool.gw_createRedpointSpine()
            v.red_point:addChild(v.red_point_spine)
        end
        v.red_point:setVisible(status)
        total_status = total_status or status
    end
    --for i=1,2 do
    --    local status = model:getLucklyTabRedPoint(i)
    --    self.sheet_btn_list[i].red_point:setVisible(status)
    --    self.tab_list[i].redpoint:setVisible(status)
    --    totle_status = totle_status or status
    --end
    --MainuiController:getInstance():setFunctionTipsStatus(MainuiConst.icon.lucky_treasure,total_status)
    MainSceneController:getInstance():setBuildRedStatus(CenterSceneBuild.luckytreasure, total_status)
end

function ActionTreasureWindow:showTreasureLog(data)
    if not data or next(data) == nil then return end

    --if not self.gw_getRewardLog then
    --    self.gw_getRewardLog = createRichLabel(22, cc.c4b(0xff,0xff,0xf8,0xff), cc.p(1,0.5), cc.p(417,23), nil, nil, 600)
    --    self.getted_info_bg:addChild(self.gw_getRewardLog)
    --end
    --self.gw_getRewardLog:setVisible(false)
    --if data.log_list and #data.log_list > 0 and data.log_list[1] then
    --    local item_config = Config.ItemData.data_get_data(data.log_list[1].bid)
    --    if item_config then
    --        self.gw_getRewardLog:setVisible(true)
    --        local str = string_format(TI18N(" <div fontcolor=#4cd849>%s</div> 获得 <div fontcolor=#ffa72a>%s</div>"),data.log_list[1].role_name, item_config.name)
    --        self.gw_getRewardLog:setString(str)
    --    end
    --end

    local str = ""
    local num = tableLen(data.log_list)
    if num >= 10 then
        num = 10
    end
    for i,v in pairs(self.getRewardList) do
        if v then
            v:setVisible(false)
        end
    end
    self.text_scroll:setInnerContainerSize(cc.size(self.text_scroll:getContentSize().width, 26*num))
    for i = 1, num do
        if data.log_list[i] then
            if not self.getRewardList[i] then
                self.getRewardList[i] = createRichLabel(22, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0,1), cc.p(0,0), nil, nil, 1000)
                self.getRewardList[i].name_label = createLabel(22, cc.c4b(0x41,0xf1,0x34,0xff),nil, 0, 0,"", self.getRewardList[i],nil, cc.p(1, 0.5))
                self.text_scroll:addChild(self.getRewardList[i])
            end
            if self.getRewardList[i] then
                StringUtil.gw_setRoleNickName(self.getRewardList[i].name_label, data.log_list[i].role_name)
                local pos_y = self.text_scroll:getInnerContainerSize().height + 47
                self.getRewardList[i]:setPositionY(pos_y - 26*(i+1))
                local item_config = Config.ItemData.data_get_data(data.log_list[i].bid)
                str = string_format(UI_TI18N(25008), item_config.name)
                self.getRewardList[i]:setString(str)

                local name_len = self.getRewardList[i].name_label:getContentSize().width
                local content_len = self.getRewardList[i]:getContentSize().width
                self.getRewardList[i].name_label:setPositionY(self.getRewardList[i]:getContentSize().height * 0.5)
                local pos_x = self.text_scroll:getContentSize().width*0.5 - (name_len + content_len)*0.5 + name_len
                self.getRewardList[i]:setPositionX(pos_x)
                self.getRewardList[i]:setVisible(true)
            end
        end
    end
end

--function ActionTreasureWindow:changeTabView(index)
--    index = index or 1
--    if self.cur_index == index then return end
--    if self.cur_tab ~= nil then
--        self.cur_tab.normal_img:setVisible(true)
--        self.cur_tab.normal_label:setVisible(true)
--        self.cur_tab.select_img:setVisible(false)
--        self.cur_tab.select_label:setVisible(false)
--    end
--
--    self.cur_index = index
--    self.cur_tab = self.tab_list[self.cur_index]
--
--    if self.cur_tab ~= nil then
--        self.cur_tab.normal_img:setVisible(false)
--        self.cur_tab.normal_label:setVisible(false)
--        self.cur_tab.select_img:setVisible(true)
--        self.cur_tab.select_label:setVisible(true)
--    end
--
--    self.touchEnable = false
--
--    local luckly_list = model:getLucklyRewardData(index)
--    local initData = model:getTreasureInitData(index)
--    self:commonShowData(initData, luckly_list)
--
--    self:itemRewardPos(initData.rand_lists)
--    self:showTreasureLog(initData)
--end

function ActionTreasureWindow:register_event()
    self:addGlobalEvent(ActionEvent.UPDATE_LUCKYROUND_GET, function(data)
        if not data then
            controller:openLuckyTreasureWin(false)
            return
        end

        self:setSheetTypeUI()
        --self:changeTabView(self.cur_index or self.jump_index)
    end)
    self:addGlobalEvent(ActionEvent.TREASURE_SUCCESS_DATA, function(data)
        if not data then return end
        if data.code == 0 then
            self.touchEnable = false
            message(data.msg)
            return
        end

        self:showLotteryAudioEffect(true)
        self.showRewardList = data
        self.pos = 0
        self.runProcess= 0
        self.process = self.status_count --开始的位置
        self.speed = 1
        self.addSpeed = 0
        self.targetPos = data.awards3[1].pos - 1 --停灯的位置(从0开始)
        self.step = 0
        self.round = 5 --圈数
        if self.targetPos <= 3 then
            self.round = 4
        end

        self:runLightUniformSpeedHide()
        if self.lottery_ticket == nil then
            self.lottery_ticket = GlobalTimeTicket:getInstance():add(function()
                self:runHandler()
            end,0.01)
        end
    end)
    self:addGlobalEvent(ActionEvent.UPDATA_TREASURE_LOG_DATA, function(data)
        if not data then return end
        model:updataTreasureLogData(data.type, data.log_list)
        local initData = model:getTreasureInitData(data.type)
        self:showTreasureLog(initData)
    end)
    --弹窗
    self:addGlobalEvent(ActionEvent.UPDATA_TREASURE_POPUPS_SEND, function(data)
        self.showRewardList = data
        self:runLightReward()
    end)

    self:addGlobalEvent(ActionEvent.UPDATE_LUCKLY_DATA, function(data)
        if not data then return end

        self:updateTopNumWealth()

        --local buy_reward_data = model:getBuyRewardData(data.type)
        --local lottery_id = buy_reward_data[1].expend_item[1][1]
        --self.hasTreasure_num[data.type] = BackpackController:getInstance():getModel():getBackPackItemNumByBid(lottery_id)
        --if self.hasTreasure_num[data.type] <= 0 then self.hasTreasure_num[data.type] = 0 end
        --
        --local item_config = Config.ItemData.data_get_data(lottery_id)
        --if item_config then
        --    loadSpriteTexture(self.right_top_container_treasure_info_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
        --    self.right_top_container_treasure_info_value:setString(self.hasTreasure_num[data.type])
        --end

        model:updataTreasureInitData(data.type, data)

        local luckly_list = model:getLucklyRewardData(data.type)
        local initData = model:getTreasureInitData(data.type)
        self:commonShowData(initData, luckly_list)
    end)

    -- 初始化或者断线重连的时候会跑出这个更新事件的
    self:addGlobalEvent(BackpackEvent.GET_ALL_DATA, function(bag_code)
        self:updateTopNumWealth()
    end)
    self:addGlobalEvent(BackpackEvent.ADD_GOODS, function(bag_code,temp_list)
        self:updateTopNumWealth()
        --self:changeTreasureNumber(temp_list)
    end)
    self:addGlobalEvent(BackpackEvent.DELETE_GOODS, function(bag_code,temp_list)
        self:updateTopNumWealth()
        --self:changeTreasureNumber(temp_list)
    end)
    self:addGlobalEvent(BackpackEvent.MODIFY_GOODS_NUM, function(bag_code,temp_list)
        self:updateTopNumWealth()
        --self:changeTreasureNumber(temp_list)
    end)
  
    --for k, tab_btn in pairs(self.tab_list) do
    --    registerButtonEventListener(tab_btn, function()
    --        if self.touchEnable == true then return end
    --        self.probablity:setVisible(false)
    --        local role_ve = RoleController:getInstance():getRoleVo()
    --        local data = model:getBuyRewardData(tab_btn.index)
    --
    --        if data and data[1].limit_open then
    --            if role_ve.lev >= data[1].limit_open[1][2] then
    --                self:changeTabLocalData(tab_btn.index)
    --                self:changeTabView(tab_btn.index)
    --            else
    --                local str = string_format(TI18N("人物等级%d级开启"),data[1].limit_open[1][2])
    --                message(str)
    --            end
    --        end
    --    end ,false, 1)
    --end

    --registerButtonEventListener(self.btnRule, function(param,sender, event_type)
    --    local config = Config.DialData.data_const.game_rule1
    --    if self.cur_index == 2 then
    --        config = Config.DialData.data_const.game_rule2
    --    end
    --    TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition(),nil,nil,500)
    --end ,false, 1)
    --
    --registerButtonEventListener(self.btnLockOther, function()
    --    self.probablity:setVisible(true)
    --    self:rewardProbility(self.cur_index)
    --end ,false, 1)
    --registerButtonEventListener(self.probablity, function()
    --    self.probablity:setVisible(false)
    --end ,false, 1)
    --registerButtonEventListener(self.background, function()
    --    self.probablity:setVisible(false)
    --end ,false, 1)
    --
    --registerButtonEventListener(self.btn_shop, function()
    --    StrongerController:getInstance():clickCallBack(406)
    --end ,false, 1)
    --
    --for i,v in ipairs(self.btnTreasure) do
    --    registerButtonEventListener(v.btn, function()
    --        self:sendTreasureLottery(i)
    --    end ,true, 1)
    --end

    if gw_role_vo then
        if self.role_update_event == nil then
            self.role_update_event = gw_role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if key == "coin" or key == "gold" then
                    self:updateTopNumWealth()
                elseif key == "lev" then 	--等级
                    self:updataExchangeRedPoint()
                end
            end)
        end
    end
    self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
        end
    end)
    self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ExchangeController:getInstance():openExchangeMainView(true)
        end
    end)
    self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            if self.cur_index == nil then return end

            local buy_reward_data = model:getBuyRewardData(self.cur_index)
            local lottery_id = buy_reward_data[1].expend_item[1][1]
            local config = Config.ItemData.data_get_data(lottery_id)
            if config then
                BackpackController:getInstance():openTipsSource(true, config)
            end
        end
    end)

    --registerButtonEventListener(self.refresh_btn, function()
    --    self:sendTreasureLottery(3)
    --end ,true, 1)

    --点金红点
    if self.coin_touch_redpoint == nil then
        self.coin_touch_redpoint = GlobalEvent:getInstance():Bind(ExchangeEvent.Extra_Reward, function(data)
            self.exchange_data = data
            self:updataExchangeRedPoint()
        end)
    end
end

function ActionTreasureWindow:showLotteryAudioEffect(status)
    if self.lottery_audio_effect then
        AudioManager:getInstance():removeEffectBySoundId(self.lottery_audio_effect)
        self.lottery_audio_effect = nil
    end
    if status then
        self.lottery_audio_effect = AudioManager:getInstance():playEffectForHandAudoRemove(AudioManager.AUDIO_TYPE.COMMON,"c_turntable_game", false)
    end
end

--
function ActionTreasureWindow:sendTreasureLottery(index)
    if not self.cur_index then return end

    if self.touchEnable == true then
        message(UI_TI18N(25009))
        return
    end
    self.cur_index = self.cur_index or 1
    if index == 3 then
        if self.touchRefresh == true then
            message(UI_TI18N(25010))
            return
        end
        local role_vo = RoleController:getInstance():getRoleVo()
        if role_vo.gold < treasure_const.refreash.val[1][2] and self.touchEffect[self.cur_index] == false then
            message(UI_TI18N(25011))
            return
        end
        self.touchRefresh = true
        self:runLightUniformSpeedHide()
        self:startRefreshAction()
    else
        -- if self.hasTreasure_num[self.cur_index] > 0 then
        --     self.lottery_audio_effect = AudioManager:getInstance():playEffectForHandAudoRemove(AudioManager.AUDIO_TYPE.COMMON,"c_turntable_game", false)
        -- end
        local data = model:getBuyRewardData(self.cur_index)
        self.touchEnable = true
        local _bool, lock_tips = MainuiController:getInstance():checkIsOpenByActivate(data[index].limit_open)
        if _bool == true then
            local id = data[index].expend_item[1][1]
            local num = data[index].expend_item[1][2]
            if self.hasTreasure_num[self.cur_index] == nil or self.hasTreasure_num[self.cur_index] < num then
                self.touchEnable = false
                local config = Config.ItemData.data_get_data(id)
                if config then
                    BackpackController:getInstance():openTipsSource(true,config)
                else
                    Debug.error("找不到道具配置！！ID:"..id)
                end
                return
            end

            self.touchTreasure_type = index
        else
            self.touchEnable = false
            message(lock_tips)
            return
        end
        controller:send16638(self.cur_index, index)
    end
end
----更改探宝劵
--function ActionTreasureWindow:changeTreasureNumber(list)
--    for i,v in pairs(list) do
--        if v.base_id == 37001 then
--            self.hasTreasure_num[1] = BackpackController:getInstance():getModel():getBackPackItemNumByBid(37001)
--            if self.cur_index == 1 then
--                local item_config = Config.ItemData.data_get_data(37001)
--                loadSpriteTexture(self.right_top_container_treasure_info_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
--                self.right_top_container_treasure_info_value:setString(self.hasTreasure_num[1])
--            end
--        elseif v.base_id == 37002 then
--            self.hasTreasure_num[2] = BackpackController:getInstance():getModel():getBackPackItemNumByBid(37002)
--            if self.cur_index == 2 then
--                local item_config = Config.ItemData.data_get_data(37002)
--                loadSpriteTexture(self.right_top_container_treasure_info_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
--                self.right_top_container_treasure_info_value:setString(self.hasTreasure_num[2])
--            end
--        end
--    end
--end

local slow_start = 3--开始减少灯的个数
function ActionTreasureWindow:runHandler()
    if self.step == 0 then
        self.process = self.process + 0.33
        if self.process >= 3 then
            self.step = 1
            self.speed = 0.5
        end
    elseif self.step == 1 then
        self.process = self.process+self.speed
        if self.process > ROUND_COUNT*self.round and self.targetPos > -1 then
            if self.targetPos > 3 then
                if (self.process % ROUND_COUNT) > slow_start then
                    self.speed = 0.04
                    self.step = 2
                end
            else
                if self.targetPos <= slow_start then
                    if (self.process % (ROUND_COUNT*self.round)) >= (self.targetPos-slow_start+ROUND_COUNT) then
                        self.speed = 0.04
                        self.step = 2
                    end
                end
            end
        end
    elseif self.step == 2 then
        self.process = self.process+self.speed
        local index = math.floor(self.process)
        if self.cur_effect_index ~= index then
            self.cur_effect_index = index
            -- print("******** self.cur_effect_index *********",self.cur_effect_index)
            if self.stop_audio_effect then
                AudioManager:getInstance():removeEffectBySoundId(self.stop_audio_effect)
            end
            self.stop_audio_effect = AudioManager:getInstance():playEffectForHandAudoRemove(AudioManager.AUDIO_TYPE.COMMON,"c_turntable_game_1", false)
        end

        if (self.process % ROUND_COUNT >= self.targetPos) and math.floor(self.process / ROUND_COUNT) >= 5 then
            if self.lottery_ticket ~= nil then
                GlobalTimeTicket:getInstance():remove(self.lottery_ticket)
                self.lottery_ticket = nil
                self.cur_effect_index = nil
                self:showLotteryAudioEffect(false)
                AudioManager:getInstance():removeEffectBySoundId(self.stop_audio_effect)
                -- print("跑灯结束~~~~~~")
                self:stopRunHandler()
            end
        end
    end
    local p,_ = math.modf(self.process)
    self:setPos(p)
end

function ActionTreasureWindow:setPos(pos)
    if pos <= 0 then
        pos  = pos + ROUND_COUNT
    elseif pos >= ROUND_COUNT then
        pos = pos % ROUND_COUNT
    end
    self.run_light:setVisible(true)
    self.run_light:setPosition(run_light_pos[change_pos[pos]][1],run_light_pos[change_pos[pos]][2])
    self.run_light:setRotation(run_light_pos[change_pos[pos]][3])
end
--跑灯结束
function ActionTreasureWindow:stopRunHandler()
    self.touchEnable = false

    if self.run_light_show_reward == nil then
        self.run_light_show_reward = GlobalTimeTicket:getInstance():add(function()
            if not tolua.isnull(self.run_light) then
                self:runLightReward()
                self.showRewardList = nil
                self:runLightUniformSpeed()
            end
        end,1.0,1)
    end
end
--抽奖奖励
function ActionTreasureWindow:runLightReward()
    if self.showRewardList then
        local award = {}
        for i,v in ipairs(self.showRewardList.awards1) do
            if v then
                table.insert(award, v)
            end
        end
        for i,v in ipairs(self.showRewardList.awards2) do
            if v then
                table.insert(award, v)
            end
        end
        --Debug.info(award)
        --类型， 次数类型
        --controller:openTreasureGetItemWindow(true, award, self.cur_index, self.touchTreasure_type)
        MainuiController:getInstance():openGetItemView(true, award, 0)
    end
    local initData = model:getTreasureInitData(self.cur_index)
    if initData then
        self:itemRewardPos(initData.rand_lists)
    else
        self.item_infos_items_node:setVisible(false)
    end
    self.showRewardList = nil
end

function ActionTreasureWindow:runLightUniformSpeedHide()
    if self.run_light then
        self.run_light:setVisible(false)
    end
    if self.open_view_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.open_view_ticket)
        self.open_view_ticket = nil
    end
    if self.run_light_show_reward ~= nil then
        GlobalTimeTicket:getInstance():remove(self.run_light_show_reward)
        self.run_light_show_reward = nil
    end
end
--没有跑灯的时候匀速跑
function ActionTreasureWindow:runLightUniformSpeed()
    if self.open_view_ticket == nil then
        self.open_view_ticket = GlobalTimeTicket:getInstance():add(function()
            if not tolua.isnull(self.run_light) then
                self.run_light:setVisible(true)
                self.status_count = self.status_count % ROUND_COUNT
                self.run_light:setPosition(run_light_pos[change_pos[self.status_count]][1],run_light_pos[change_pos[self.status_count]][2])
                self.run_light:setRotation(run_light_pos[change_pos[self.status_count]][3])
                self.status_count = self.status_count + 1
            end
        end,0.5)
    end
end

function ActionTreasureWindow:getActionFunc(node)
    if not node then return end
    local fadeout = cc.FadeOut:create(0.07)
    node:runAction(fadeout)
end

function ActionTreasureWindow:startRefreshAction()
    controller:send16642(self.cur_index)
    self:handleEffect()

    --local openSingle = {}
    --for i=1, 8 do
    --    local function test()
    --        if self.item_list[i] then
    --            self:getActionFunc(self.item_list[i])
    --        end
    --    end
    --    openSingle[i] = cc.CallFunc:create(test)
    --end
    --local actionNode = cc.Node:create()
    --self.item_infos_items_node:addChild(actionNode)
    --local function func()
    --    controller:send16642(self.cur_index)
    --    self:handleEffect()
    --end
    --actionNode:runAction(cc.Sequence:create(openSingle[1],openSingle[2],openSingle[3],openSingle[4],openSingle[5],openSingle[6],
    --                                        openSingle[7],openSingle[8],openSingle[9],openSingle[10],openSingle[11],openSingle[12],
    --                                        cc.CallFunc:create(func),cc.RemoveSelf:create(true)))
end
--特效
function ActionTreasureWindow:handleEffect()
    if self.item_list ~= nil then
        for i,v in pairs(self.item_list) do
            v:setOpacity(0)
        end
    end

    self.touchRefresh = false
    local initData = model:getTreasureInitData(self.cur_index)
    self:itemRewardPos(initData.rand_lists)

    --local function func()
    --    self.touchRefresh = false
    --    local initData = model:getTreasureInitData(self.cur_index)
    --    self:itemRewardPos(initData.rand_lists)
    --end
    --playEffectOnce(PathTool.getEffectRes(614),0,0,
    --                self.item_infos_items_node,func, nil, nil, nil, PlayerAction.action_1, 1)
end

function ActionTreasureWindow:close_callback( )
    doStopAllActions(self.item_infos_items_node)
    --doStopAllActions(self.main_container)
    doStopAllActions(self.refresh_time_label)

    self.cur_index = nil
    if self.sheet_btn_list then
        for i,sheet in pairs(self.sheet_btn_list) do
            if sheet.red_point_spine ~= nil then
                sheet.red_point_spine:setVisible(false)
                sheet.red_point_spine:removeFromParent()
                sheet.red_point_spine = nil
            end
            if sheet.spine then
                sheet.spine:clearTracks()
                sheet.spine:removeFromParent()
                sheet.spine = nil
            end
        end
        self.sheet_btn_list = nil
    end
    self.top_num_wealth_list = nil

    if self.role_update_event ~= nil then
        gw_role_vo:UnBind(self.role_update_event)
        self.role_update_event = nil
    end

    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end

    if self.lucky_info_reward_list ~= nil then
        for i,v in pairs(self.lucky_info_reward_list) do
            if v.redpoint_spine ~= nil then
                v.redpoint_spine:clearTracks()
                v.redpoint_spine:removeFromParent()
                v.redpoint_spine = nil
            end
        end

        self.lucky_info_reward_list = nil
    end



    if self.lottery_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.lottery_ticket)
        self.lottery_ticket = nil
    end
    self:showLotteryAudioEffect(false)
    AudioManager:getInstance():removeEffectBySoundId(self.stop_audio_effect)
    if self.item_list and next(self.item_list or {}) ~= nil then
        for i, v in ipairs(self.item_list) do
            if v and v.DeleteMe then
                v:DeleteMe()
            end
        end
    end

    if self.gw_luckly_item and next(self.gw_luckly_item or {}) ~= nil then
        for i, v in ipairs(self.gw_luckly_item) do
            for j=1,3 do
                if v.item_list[j] and v.item_list[j].DeleteMe then
                    v.item_list[j]:DeleteMe()
                end
            end
        end
    end
    --if self.luckly_item and next(self.luckly_item or {}) ~= nil then
    --    for i, v in ipairs(self.luckly_item) do
    --        if v and v.DeleteMe then
    --            v:DeleteMe()
    --        end
    --    end
    --end


    for i,v in pairs(self.round_certer_load) do
        if v and v.DeleteMe then
            v:DeleteMe()
        end
        v = nil
    end

    self:runLightReward()

    if self.probablity then
        doStopAllActions(self.probablity)
    end
    self:runLightUniformSpeedHide()

    self.exchange_data = nil
    if self.coin_redpoint_spine ~= nil then
        self.coin_redpoint_spine:clearTracks()
        self.coin_redpoint_spine:removeFromParent()
        self.coin_redpoint_spine = nil
    end
    if self.coin_touch_redpoint then
        GlobalEvent:getInstance():UnBind(self.coin_touch_redpoint)
        self.coin_touch_redpoint = nil
    end


    controller:openLuckyTreasureWin(false)
end

--点击页签
function ActionTreasureWindow:onClickSheetBtn(index)
    if self.cur_index == index then
        return
    end

    --local role_ve = RoleController:getInstance():getRoleVo()
    local data = model:getBuyRewardData(index)
    if data and data[1].limit_open then
        local _bool, lock_tips = MainuiController:getInstance():checkIsOpenByActivate(data[1].limit_open)
        if _bool == false then
            message(lock_tips)
            return
        end
        --if role_ve.lev < data[1].limit_open[1][2] then
        --    local str = string_format(TI18N("人物等级%d级开启"),data[1].limit_open[1][2])
        --    message(str)
        --    return
        --end
    end

    if self.item_list ~= nil then
        for i,v in pairs(self.item_list) do
            v:setOpacity(0)
        end
    end

    self.touchEnable = false
    self.cur_index = index

    self:setSheetTypeUI()
end
--根据页签类型刷新页签
function ActionTreasureWindow:setSheetTypeUI()
    for i,v in pairs(self.sheet_btn_list) do
        v.normal:setVisible(true)
        v.select:setVisible(false)
        v.spine_flag = false
    end
    self.sheet_btn_list[self.cur_index].normal:setVisible(false)
    self.sheet_btn_list[self.cur_index].select:setVisible(true)

    self.sheet_btn_list[self.cur_index].spine_flag = true
    self.sheet_btn_list[self.cur_index].spine:setAnimation(0, "anniu_xuanzhong", false)

    local bg_res = ""
    if self.cur_index == 1 then
        bg_res = PathTool.getPlistImgForDownLoad("gw_action", "gw_action_treasure_01_b_bg_zhuanpan1", true)
    else
        bg_res = PathTool.getPlistImgForDownLoad("gw_action", "gw_action_treasure_01_b_bg_zhuanpan2", true)
    end
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)

    local round_res = ""
    if self.cur_index == 1 then
        round_res = PathTool.getResFrame("gw_action/gw_action_treasure", "gw_action_treasure_03_zp_chuji1")
    else
        round_res = PathTool.getResFrame("gw_action/gw_action_treasure", "gw_action_treasure_03_zp_chuji2")
    end
    self.item_infos_round:loadTexture(round_res, LOADTEXT_TYPE_PLIST)
    local run_light_res = ""
    if self.cur_index == 1 then
        run_light_res = PathTool.getResFrame("gw_action/gw_action_treasure", "gw_action_treasure_02_xuanze1")
    else
        run_light_res = PathTool.getResFrame("gw_action/gw_action_treasure", "gw_action_treasure_02_xuanze2")
    end
    loadSpriteTexture(self.run_light, run_light_res, LOADTEXT_TYPE_PLIST)

    self:updateTopNumWealth()
    self:updateTreasureBtns()

    local luckly_list = model:getLucklyRewardData(self.cur_index)
    local initData = model:getTreasureInitData(self.cur_index)
    self:commonShowData(initData, luckly_list)

    self:itemRewardPos(initData.rand_lists)
    self:showTreasureLog(initData)

    --doStopAllActions(self.main_container)
    ----self.main_container:setOpacity(0)
    ----local action = cc.FadeIn:create(0.2)
    --self.main_container:runAction(cc.Sequence:create(cc.FadeOut:create(0.1), cc.FadeIn:create(0.1)))
end
--刷新上方货币
function ActionTreasureWindow:updateTopNumWealth()
    if not self.top_num_wealth_list then return end

    if self.top_num_wealth_list[1] ~= nil then
        local key = "gold"
        local key_value = gw_role_vo[key] or 0
        self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[1].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[1].btn:setVisible(true)
    end
    if self.top_num_wealth_list[2] ~= nil then
        local key = "coin"
        local key_value = gw_role_vo[key] or 0
        self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[2].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[2].btn:setVisible(true)
    end
    if self.top_num_wealth_list[3] ~= nil then
        local buy_reward_data = model:getBuyRewardData(self.cur_index)
        local lottery_id = buy_reward_data[1].expend_item[1][1]
        local item_config = Config.ItemData.data_get_data(lottery_id)
        local res = PathTool.getItemRes(item_config.icon)
        loadSpriteTexture(self.top_num_wealth_list[3].icon, res, LOADTEXT_TYPE)
        self.hasTreasure_num[self.cur_index] = BackpackController:getInstance():getModel():getBackPackItemNumByBid(lottery_id)
        self.top_num_wealth_list[3].value:setString(self.hasTreasure_num[self.cur_index])

        self.top_num_wealth_list[3].btn:setVisible(true)
    end
end

--更新点金红点
function ActionTreasureWindow:updataExchangeRedPoint()
    if not self.exchange_data then
        return
    end
    local red_lev_min =  Config.ConvertData.data_trade_cost.red_lev_min
    for i,v in ipairs(self.exchange_data.list) do
        if v.id == 1 and self.coin_redpoint then
            local status = false
            if (v.max - v.num) > 0 and gw_role_vo and red_lev_min and red_lev_min.val <= gw_role_vo.lev then
                status = true
            end
            if status == true then
                if self.coin_redpoint_spine == nil then
                    self.coin_redpoint_spine = PathTool.gw_createRedpointSpine()
                    self.coin_redpoint_spine:setPosition(40,32)
                    self.coin_redpoint:addChild(self.coin_redpoint_spine)
                end
                self.coin_redpoint_spine:setVisible(true)
                break
            else
                if self.coin_redpoint_spine then
                    self.coin_redpoint_spine:setVisible(false)
                end
            end
        end
    end
end
--刷新按钮
function ActionTreasureWindow:updateTreasureBtns()
    if self.cur_index == nil then return end

    if self.cur_index == 1 then--初级转盘
        self.btn_treasure_1_label:setString(string.format(UI_TI18N(25012), treasure_const.treasure_num.val[self.cur_index][1]))
        self.btn_treasure_2_label:setString(string.format(UI_TI18N(25013), treasure_const.treasure_num.val[self.cur_index][2]))
    elseif self.cur_index == 2 then--高级转盘
        self.btn_treasure_1_label:setString(string.format(UI_TI18N(25014), treasure_const.treasure_num.val[self.cur_index][1]))
        self.btn_treasure_2_label:setString(string.format(UI_TI18N(25015), treasure_const.treasure_num.val[self.cur_index][2]))
    end

    local buy_reward_data = model:getBuyRewardData(self.cur_index)
    local lottery_id = buy_reward_data[1].expend_item[1][1]
    local item_config = Config.ItemData.data_get_data(lottery_id)
    local res = PathTool.getItemRes(item_config.icon)
    loadSpriteTexture(self.treasure_1_consume_icon, res, LOADTEXT_TYPE)
    loadSpriteTexture(self.treasure_2_consume_icon, res, LOADTEXT_TYPE)
    local have_num = self.hasTreasure_num[self.cur_index]
    self.treasure_1_consume_num:setString(buy_reward_data[1].expend_item[1][2])
    self.treasure_2_consume_num:setString(buy_reward_data[2].expend_item[1][2])

    self.btn_treasure_1:setVisible(true)
    self.btn_treasure_2:setVisible(true)
    self.treasure_1_consume:setVisible(true)
    self.treasure_2_consume:setVisible(true)
end
--刷新幸运值
function ActionTreasureWindow:updateLuckyInfos(data, luckly_list)
    if not next(data) or not next(luckly_list) then
        self.lucky_info:setVisible(false)
        return
    end

    local lucky_num = 0
    if luckly_list[5] then
        lucky_num = luckly_list[5].lucky_val
    end
    self.lucky_info_value_label1:setString(data.lucky)
    self.lucky_info_value_label2:setString("/"..lucky_num)
    self.lucky_info_value_label2:setPositionX(self.lucky_info_value_label1:getPositionX() + self.lucky_info_value_label1:getContentSize().width)
    local with = self.lucky_info_value_label1:getContentSize().width + self.lucky_info_value_label2:getContentSize().width + 34
    if with < 139 then with = 139 end
    self.lucky_info_value_bg:setContentSize(cc.size(with, 40))

    local mul = self:sectionCalculation(data.lucky, luckly_list)
    self.lucky_info_bar:setPercent(mul)
    self.lucky_info_bar_tab:setPositionY(102 + 530*mul/100)

    local status = false
    for i,v in pairs(self.lucky_info_reward_list) do
        local config = luckly_list[i]
        if config ~= nil then
            local _bool = true
            local getted = false
            for k,m in pairs(data.lucky_award) do
                if config.id == m.lucky then
                    _bool = false
                    getted = true
                    break
                end
            end

            if data.lucky < config.lucky_val then
                _bool = false
            end

            if _bool == true then
                status = true
            end

            if _bool == true and v.redpoint_spine == nil then
                v.redpoint_spine = PathTool.gw_createRedpointSpine()
                v.redpoint:addChild(v.redpoint_spine)
            end
            v.redpoint:setVisible(_bool)
            v.btn:setVisible(_bool)
            v.num:setString(config.lucky_val)
            if #config.award >= 1 then
                if v.item1 == nil then
                    v.item1 = GW_GoodsItem3.new(true, true, false, 0.44, false, true)
                    v.item1:setDefaultTip(true)
                    v.item1_node:addChild(v.item1)
                end
                v.item1:setBaseData(config.award[1][1], config.award[1][2])
                v.item1:gw_showGetted(getted)
                --setChildUnEnabled(getted, v.item1)
                v.item1_node:setVisible(true)
            else
                v.item1_node:setVisible(false)
            end

            if #config.award >= 2 then
                if v.item2 == nil then
                    v.item2 = GW_GoodsItem3.new(true, true, false, 0.44, false, true)
                    v.item2:setDefaultTip(true)
                    v.item2_node:addChild(v.item2)
                end
                v.item2:setBaseData(config.award[2][1], config.award[2][2])
                v.item2:gw_showGetted(getted)
                --setChildUnEnabled(getted, v.item2)
                v.item2_node:setVisible(true)
            else
                v.item2_node:setVisible(false)
            end

            setChildUnEnabled(data.lucky < config.lucky_val, v)
            v:setVisible(true)
        else
            Debug.error("幸运值配置错误！！")
            v:setVisible(false)
        end
    end

    model:setLucklyTabRedPoint(data.type,status)
    self:showRedpoint()

    self.lucky_info:setVisible(true)
end
--刷新免费刷新按钮
function ActionTreasureWindow:updateRefreshBtnStatus(data, luckly_list)
    if not next(data) or not next(luckly_list) then
        doStopAllActions(self.refresh_time_label)
        self.refresh_time_label:setVisible(false)
        self.refresh_btn:setVisible(false)
        return
    end

    local refresh = data.end_time - GameNet:getInstance():getTime()
    if refresh > 0 then
        doStopAllActions(self.refresh_time_label)

        self.gw_refresh_need_num = treasure_const.refreash.val[1][2]
        local item_config = Config.ItemData.data_get_data(treasure_const.refreash.val[1][1])
        loadSpriteTexture(self.refresh_btn_cost_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
        self.refresh_btn_cost_label:setString(self.gw_refresh_need_num)
        self.refresh_btn_cost_icon:setPositionX(-(self.refresh_btn_cost_label:getContentSize().width + 32)/2)
        self.refresh_btn_cost_label:setPositionX(self.refresh_btn_cost_icon:getPositionX() + 32)
        self.refresh_btn_free:setVisible(false)
        self.refresh_btn_cost:setVisible(true)
        self.refresh_time_label:setString(string.format(UI_TI18N(25016), TimeTool.GetTimeForFunction(refresh)))
        self.refresh_time_label:setVisible(true)
        self.refresh_time_label:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(1), cc.CallFunc:create(function()
            refresh = refresh - 1
            if refresh < 0 then
                doStopAllActions(self.refresh_time_label)
                self.gw_refresh_need_num = 0
                self.refresh_btn_free:setVisible(true)
                self.refresh_btn_cost:setVisible(false)
                self.refresh_time_label:setVisible(false)
                self.touchEffect[data.type] = true
            else
                self.refresh_time_label:setString(string.format(UI_TI18N(25016), TimeTool.GetTimeForFunction(refresh)))
            end
        end))))

        self.touchEffect[data.type] = false
    else
        doStopAllActions(self.refresh_time_label)
        self.gw_refresh_need_num = 0
        self.refresh_btn_free:setVisible(true)
        self.refresh_btn_cost:setVisible(false)
        self.refresh_time_label:setVisible(false)
        self.touchEffect[data.type] = true
    end

    self.refresh_btn:setVisible(true)
end

