--------------------------------------------
-- @Author  : htp
-- @Editor  : htp
-- @Date    : 2018-11-20 17:10:31
-- @description    : 
		-- 先知殿主界面
---------------------------------
SeerpalaceMainWindow = SeerpalaceMainWindow or BaseClass(BaseView)

local controller = SeerpalaceController:getInstance()
local model = controller:getModel()

local table_insert = table.insert
local table_sort = table.sort

function SeerpalaceMainWindow:__init()
	self.win_type = WinType.Full
	self.is_full_screen = true
	self.res_list = {
		{path = PathTool.getPlistImgForDownLoad("gw_seerpalace", "gw_seerpalace"), type = ResourcesType.plist},
		{path = PathTool.getPlistImgForDownLoad("gw_seerpalace","1_bg_xianzhi",true), type = ResourcesType.single },
	}
	self.layout_name = "seerpalace/gw_seerpalace_main_window"
	self.panel_list = {}
	self.tab_list = {}
	--self.label_list = {}


	self.role_vo = RoleController:getInstance():getRoleVo()
end

function SeerpalaceMainWindow:open_callback(  )
	self.left_top_container = self.root_wnd:getChildByName("left_top_container")
	self.left_top_container:setPositionX(display.getLeft())
	self.left_top_container:setPositionY(display.getTop())
	self.right_top_container = self.root_wnd:getChildByName("right_top_container")
	self.right_top_container:setPositionX(display.getRight())
	self.right_top_container:setPositionY(display.getTop())
	self.bottom_container = self.root_wnd:getChildByName("bottom_container")
	self.bottom_container:setPositionY(display.getBottom())
	self.sheet_node = self.bottom_container:getChildByName("sheet_node")
	self.sheet_node:setPositionX(display.getRight())
	self.bottom_bg = self.bottom_container:getChildByName("bg")
	self.bottom_bg:setContentSize(cc.size(display.width, 120))

	--背景
	self.background = self.root_wnd:getChildByName("background")
	self.background:setScale(display.getMaxScale())
	local bg_res = PathTool.getPlistImgForDownLoad("gw_seerpalace", "1_bg_xianzhi", true)
	if not self.background_load then
		self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
	end

	--返回上一级
	self.back_btn = self.left_top_container:getChildByName("back_btn")
	self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
	self.back_btn:addTouchEventListener(function(sender, event_type)
		customClickAction(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			playButtonSound2()
			controller:openSeerpalaceMainWindow(false)
		end
	end)
	--返回主城
	self.home_btn = self.right_top_container:getChildByName("home_btn")
	self.home_btn:addTouchEventListener(function(sender, event_type)
		customClickAction(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			BackToHome()
		end
	end)

	--上方资产
	self.top_num_wealth_list = {}
	for i=1,3 do
		self.top_num_wealth_list[i] = {}
		if i==1 then
			self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
		elseif i==2 then
			self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
		else
			self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
		end
		self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
		self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")

		if i==1 then
			local key = "gold"
			local item_id = Config.ItemData.data_assets_label2id[key]
			local item_config = Config.ItemData.data_get_data(item_id)
			if item_config ~= nil then
				loadSpriteTexture(self.top_num_wealth_list[i].icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
			else
				Debug.error("找不到道具配置！！ID:"..item_id)
			end
		elseif i==2 then
			local key = "coin"
			local item_id = Config.ItemData.data_assets_label2id[key]
			local item_config = Config.ItemData.data_get_data(item_id)
			if item_config ~= nil then
				loadSpriteTexture(self.top_num_wealth_list[i].icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
			else
				Debug.error("找不到道具配置！！ID:"..item_id)
			end
		elseif i==3 then
			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_ZhiHui)
			if item_config ~= nil then
				loadSpriteTexture(self.top_num_wealth_list[i].icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
			else
				Debug.error("找不到先知水晶道具配置！！ID:"..SeerpalaceConst.Good_ZhiHui)
			end
		end
	end
	self.coin_redpoint = self.top_num_wealth_list[2].btn:getChildByName("add")

	self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
		customClickAction(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			playButtonSound2()
			VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
		end
	end)
	self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
		customClickAction(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			playButtonSound2()
			ExchangeController:getInstance():openExchangeMainView(true)
		end
	end)
	self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
		customClickAction(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			playButtonSound2()
			local config = Config.ItemData.data_get_data(SeerpalaceConst.Good_ZhiHui)
			if config then
				BackpackController:getInstance():openTipsSource(true, config)
			end
		end
	end)

	self.cost_info_list = {}
	for i=1,2 do
		self.cost_info_list[i] = self.root_wnd:getChildByName(string.format("cost%d_info", i))
		self.cost_info_list[i].icon = self.cost_info_list[i]:getChildByName("icon")
		self.cost_info_list[i].label = self.cost_info_list[i]:getChildByName("label")

		if i==1 then
			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_XianZhi)
			if item_config ~= nil then
				loadSpriteTexture(self.cost_info_list[i].icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
			else
				Debug.error("找不到先知精华道具配置！！ID:"..SeerpalaceConst.Good_XianZhi)
			end
		elseif i==2 then
			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_JieJing)
			if item_config ~= nil then
				loadSpriteTexture(self.cost_info_list[i].icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
			else
				Debug.error("找不到先知结晶道具配置！！ID:"..SeerpalaceConst.Good_JieJing)
			end
		end
	end
	self.cost_info_list[1]:setPositionX(display.getRight())
	self.cost_info_list[1]:setPositionY(display.getBottom())
	self.cost_info_list[2]:setPositionX(display.getRight())
	self.cost_info_list[2]:setPositionY(display.getBottom())

	--页签
	self.sheet_btn_list = {}
	for i=1,2 do
		self.sheet_btn_list[i] = self.sheet_node:getChildByName("sheet_btn"..i)
		self.sheet_btn_list[i].normal = self.sheet_btn_list[i]:getChildByName("normal")
		self.sheet_btn_list[i].select = self.sheet_btn_list[i]:getChildByName("select")
		local str = UI_TI18N(5001)
		if i==2 then str = UI_TI18N(5002) end
		self.sheet_btn_list[i].normal:getChildByName("label"):setString(str)
		self.sheet_btn_list[i].select:getChildByName("label"):setString(str)
		self.sheet_btn_list[i].red_point = self.sheet_node:getChildByName("red_point"..i)
		self.sheet_btn_list[i]:addTouchEventListener(function(sender, event_type)
			if event_type == ccui.TouchEventType.ended then
				if self.gw_summon ~= nil and self.gw_summon == true then return end
				playButtonSound2()
				self:onClickSheetBtn(i)
			end
		end)
	end
	local spine_node = self.sheet_btn_list[1].select:getChildByName("spine_node")
	function onSheetBtn1SpineCallBack()
		if self.sheet_btn_list[1].spine_flag == true then
			self.sheet_btn_list[1].spine_flag = false
			self.sheet_btn_list[1].spine:setAnimation(0, "anniu_xunhuan", true)
		end
	end
	self.sheet_btn_list[1].spine_flag = false
	self.sheet_btn_list[1].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn1SpineCallBack)
	spine_node:addChild(self.sheet_btn_list[1].spine)
	local spine_node = self.sheet_btn_list[2].select:getChildByName("spine_node")
	function onSheetBtn2SpineCallBack()
		if self.sheet_btn_list[2].spine_flag == true then
			self.sheet_btn_list[2].spine_flag = false
			self.sheet_btn_list[2].spine:setAnimation(0, "anniu_xunhuan", true)
		end
	end
	self.sheet_btn_list[2].spine_flag = false
	self.sheet_btn_list[2].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn2SpineCallBack)
	spine_node:addChild(self.sheet_btn_list[2].spine)

	self.tips_btn = self.left_top_container:getChildByName("tips_btn")
	self.tips_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			if self.sheet == nil then return end
			if self.sheet == 1 then
				local config = Config.RecruitHighData.data_seerpalace_const.game_rule1
				TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition())
			elseif self.sheet == 2 then
				local config = Config.RecruitHighData.data_seerpalace_const.game_rule2
				TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition())
			end
		end
	end)

	self.score_summon_btn = self.root_wnd:getChildByName("score_summon_btn")
	self.score_summon_btn:setPositionX(display.getLeft() + 91)
	self.score_summon_btn:setPositionY(display.getTop() - 187)
	self.score_summon_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			controller:openSeerpalaceSummonScoreWindow(true)--积分召唤
			--self:_onScoreSummonBtn()
		end
	end)
	self.score_summon_btn_redpoint = self.score_summon_btn:getChildByName("redpoint")
	self.score_summon_btn_label = self.score_summon_btn:getChildByName("label")
	self.shop_btn = self.root_wnd:getChildByName("shop_btn")
	self.shop_btn:setPositionX(display.getRight() - 58)
	self.shop_btn:setPositionY(display.getTop() - 262)
	self.shop_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			--self:_onClickShopBtn()
			controller:openSeerpalaceShopWindow(true)--先知商店
		end
	end)
	self.shop_btn_label = self.shop_btn:getChildByName("label")
	StringUtil.gw_setLabelContent(self.shop_btn_label, UI_TI18N(5019), 116)
	self.gift_btn = self.root_wnd:getChildByName("gift_btn")
	self.gift_btn:setPositionX(display.getRight() - 58)
	self.gift_btn:setPositionY(display.getTop() - 140)
	self.gift_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.gw_summon ~= nil and self.gw_summon == true then return end
			FunctionNotOpenTips()
			--self:_onClickGiftBtn()
			--JumpController:getInstance():jumpViewByEvtData({7, VIPTABCONST.PRIVILEGE})--水晶礼包
		end
	end)
	self.gift_btn_label = self.gift_btn:getChildByName("label")
	StringUtil.gw_setLabelContent(self.gift_btn_label, UI_TI18N(5020), 116)


	--self.background = self.root_wnd:getChildByName("background")
    --self.background:setScale(display.getMaxScale())
	--
	--self.left_top_container = self.root_wnd:getChildByName("left_top_container")
	--self.left_top_container:setPositionY(display.getTop())
	--self.left_top_container:setPositionX(display.getLeft())
	--self.right_top_container = self.root_wnd:getChildByName("right_top_container")
	--self.right_top_container:setPositionY(display.getTop())
	--self.right_top_container:setPositionX(display.getRight())
	--self.left_bottom_container = self.root_wnd:getChildByName("left_bottom_container")
	--self.left_bottom_container:setPositionY(display.getBottom())
	--self.left_bottom_container:setPositionX(display.getLeft())

	self.seerpalace_summon_panel = self.root_wnd:getChildByName("seerpalace_summon_panel")
	self.seerpalace_change_panel = self.root_wnd:getChildByName("seerpalace_change_panel")
	--self.seerpalace_change_panel_left_bottom_container = self.seerpalace_change_panel:getChildByName("left_bottom_container")
	--self.seerpalace_change_panel_left_bottom_container:setPositionY(display.getBottom())
	--self.seerpalace_change_panel_left_bottom_container:setPositionX(display.getLeft())
	--self.seerpalace_change_panel_right_bottom_container = self.seerpalace_change_panel:getChildByName("right_bottom_container")
	--self.seerpalace_change_panel_right_bottom_container:setPositionY(display.getBottom())
	--self.seerpalace_change_panel_right_bottom_container:setPositionX(display.getRight())

	----返回上一级
	--self.back_btn = self.left_top_container:getChildByName("back_btn")
	--self.back_btn:addTouchEventListener(function(sender, event_type)
	--	if event_type == ccui.TouchEventType.ended then
	--		playButtonSound2()
	--		controller:openSeerpalaceMainWindow(false)
	--	end
	--end)
	----返回主城
	--self.home_btn = self.right_top_container:getChildByName("home_btn")
	--self.home_btn:addTouchEventListener(function(sender, event_type)
	--	if event_type == ccui.TouchEventType.ended then
	--		BackToHome()
	--	end
	--end)
	----上方资产
	--self.top_num_wealth_list = {}
	--for i=1,3 do
	--	self.top_num_wealth_list[i] = {}
	--	if i==1 then
	--		self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
	--	elseif i==2 then
	--		self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
	--	else
	--		self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
	--	end
	--	self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
	--	self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("value")
	--end
	--
	--self.seerpalace_summon_title = self.left_top_container:getChildByName("seerpalace_summon_title")
	--self.seerpalace_summon_title_explain_btn = self.seerpalace_summon_title:getChildByName("explain_btn")
	--self.seerpalace_summon_title_explain_btn:setVisible(false)
	--self.seerpalace_change_title = self.left_top_container:getChildByName("seerpalace_change_title")
	--self.seerpalace_change_title_explain_btn = self.seerpalace_change_title:getChildByName("explain_btn")
	--self.seerpalace_change_title_explain_btn:setVisible(false)

	--local tab_name_list = {
	--    [1] = UI_TI18N(5001),
	--    [2] = UI_TI18N(5002)
	--}
	--for i=1,2 do
	--    local tab_btn = self.right_top_container:getChildByName("tab_btn_"..i)
	--    if tab_btn then
	--        local object = {}
	--        object.unselect_bg = tab_btn:getChildByName('unselect_bg')
	--		object.unselect_bg:getChildByName('label'):setString(tab_name_list[i])
	--        object.unselect_bg:setVisible(true)
	--        object.select_bg = tab_btn:getChildByName('select_bg')
	--		object.select_bg:getChildByName('label'):setString(tab_name_list[i])
	--        object.select_bg:setVisible(false)
	--        -- object.label:setTextColor(cc.c4b(0xcf, 0xb5, 0x93, 0xff))
	--        --object.lable = tab_btn:getChildByName("title")
	--        --object.lable:setString(tab_name_list[i])
	--        object.tab_btn = tab_btn
	--        object.index = i
	--        self.tab_list[i] = object
	--    end
	--end

	--self.btn_shop = self.right_top_container:getChildByName("btn_shop")
	--self.btn_gift = self.right_top_container:getChildByName("btn_gift")
	--self.btn_score_summons = self.right_top_container:getChildByName("btn_score_summons")
	--for i=1,3 do
	--	local score_bg = self.left_bottom_container:getChildByName("score_bg_" .. i)
	--	if score_bg then
	--		local score_label = score_bg:getChildByName("score_label")
	--		local score_image = score_bg:getChildByName("score_image")
	--		local cur_num = 0
	--		if i == 1 then
	--			cur_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_ZhiHui)
	--			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_ZhiHui)
	--			if item_config then
	--				loadSpriteTexture(score_image, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
	--			end
	--		elseif i == 2 then
	--			cur_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_XianZhi)
	--			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_XianZhi)
	--			if item_config then
	--				loadSpriteTexture(score_image, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
	--			end
	--		elseif i == 3 then
	--			cur_num = self.role_vo.recruithigh_hero
	--			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_JieJing)
	--			if item_config then
	--				loadSpriteTexture(score_image, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
	--			end
	--		end
	--		score_label:setString(cur_num)
	--		self.label_list[i] = score_label
	--	end
	--end

	----先知召唤
	--self.seerpalace_summon_panel_tips = self.seerpalace_summon_panel:getChildByName("tips")
	--self.seerpalace_summon_panel_tips:setString(UI_TI18N(5010))
	--self.seerpalace_summon_panel_pos_list = {}
	--for i=1,5 do
	--	local pos_root = self.seerpalace_summon_panel:getChildByName("pos_" .. i)
	--	self.seerpalace_summon_panel_pos_list[i] = pos_root
	--	local group_id = SeerpalaceConst.Index_To_GroupId[i]
	--	local config = Config.RecruitHighData.data_seerpalace_data[group_id]
	--	if config and config.item_once then
	--		self.seerpalace_summon_panel_pos_list[i].summon_cost = config.item_once[1] -- 召唤所需道具id和数量
	--		self.seerpalace_summon_panel_pos_list[i].group_id = group_id
	--	else
	--		Debug.log("找不到先知召唤配置（data_seerpalace_data）group_id："..group_id)
	--	end
	--	self.seerpalace_summon_panel_pos_list[i].index = i
	--	self.seerpalace_summon_panel_pos_list[i].icon = pos_root:getChildByName("icon")
	--	self.seerpalace_summon_panel_pos_list[i].check_btn = pos_root:getChildByName("check_btn")
	--	-- 引导需要
	--	self.seerpalace_summon_panel_pos_list[i]:setName("guide_card_" .. i)
	--end
	--self.seerpalace_summon_panel_summon_btn = self.seerpalace_summon_panel:getChildByName("summon_btn")
	--self.seerpalace_summon_panel_summon_btn_label = self.seerpalace_summon_panel_summon_btn:getChildByName("label")
	--self.seerpalace_summon_panel_summon_btn_label:setString(UI_TI18N(5011))
	--self.seerpalace_summon_panel_summon_btn_consume_bg = self.seerpalace_summon_panel_summon_btn:getChildByName("consume_bg")
	--self.seerpalace_summon_panel_summon_btn_consume_bg_icon = self.seerpalace_summon_panel_summon_btn_consume_bg:getChildByName("icon")
	--self.seerpalace_summon_panel_summon_btn_consume_bg_label = self.seerpalace_summon_panel_summon_btn_consume_bg:getChildByName("label")

	----英雄转换
	--self.hero_list_container = self.seerpalace_change_panel_left_bottom_container:getChildByName("hero_list_container")
	--self.hero_list_container_size = cc.size(display.width - 782, display.height - 295)
	--self.camp_node = self.seerpalace_change_panel_left_bottom_container:getChildByName("camp_node")
	--self.camp_node:setPositionY(display.height - 98)
	----英雄阵营
	--self.camp_btn_list = {}
	--for index=0,6 do
	--	self.camp_btn_list[index] = self.camp_node:getChildByName("camp_btn"..index)
	--	self.camp_btn_list[index]:addTouchEventListener(function(sender, event_type)
	--		if event_type == ccui.TouchEventType.ended then
	--			playButtonSound2()
	--			self:_onClickCampBtn(index)
	--		end
	--	end)
	--	self.camp_btn_list[index].normal = self.camp_btn_list[index]:getChildByName("normal")
	--	self.camp_btn_list[index].select = self.camp_btn_list[index]:getChildByName("select")
	--	self.camp_btn_list[index].index = index
	--end
	--
	--self.left_info_panel = self.seerpalace_change_panel_right_bottom_container:getChildByName("left_info_panel")
	--self.left_info_panel_empty_icon = self.left_info_panel:getChildByName("empty_icon")
	--self.left_info_panel_spine_node = self.left_info_panel:getChildByName("spine_node")
	--self.left_info_panel_lev_bg = self.left_info_panel:getChildByName("lev_bg")
	--self.left_info_panel_lev_bg_label = self.left_info_panel_lev_bg:getChildByName("label")
	--self.left_info_panel_camp_type = self.left_info_panel:getChildByName("camp_type")
	--self.left_info_panel_name = self.left_info_panel:getChildByName("name")
	--self.left_info_panel_star_con = self.left_info_panel:getChildByName("star_con")
	--self.left_info_panel_star_list = {}
	--for i=1,10 do
	--	self.left_info_panel_star_list[i] = self.left_info_panel_star_con:getChildByName("star"..i)
	--end
	--
	--self.right_info_panel = self.seerpalace_change_panel_right_bottom_container:getChildByName("right_info_panel")
	--self.right_info_panel_empty_icon = self.right_info_panel:getChildByName("empty_icon")
	--self.right_info_panel_spine_node = self.right_info_panel:getChildByName("spine_node")
	--self.right_info_panel_lev_bg = self.right_info_panel:getChildByName("lev_bg")
	--self.right_info_panel_lev_bg_label = self.right_info_panel_lev_bg:getChildByName("label")
	--self.right_info_panel_camp_type = self.right_info_panel:getChildByName("camp_type")
	--self.right_info_panel_name = self.right_info_panel:getChildByName("name")
	--self.right_info_panel_star_con = self.right_info_panel:getChildByName("star_con")
	--self.right_info_panel_star_list = {}
	--for i=1,10 do
	--	self.right_info_panel_star_list[i] = self.right_info_panel_star_con:getChildByName("star"..i)
	--end
	--
	--self.change_btn = self.seerpalace_change_panel_right_bottom_container:getChildByName("change_btn")
	--self.change_btn:setVisible(false)
	--local btn_size = self.change_btn:getContentSize()
	--self.change_btn_label = self.change_btn:getChildByName("label")
	--self.change_btn_label:setString(UI_TI18N(5012))
	--self.change_btn_consume_bg = self.change_btn:getChildByName("consume_bg")
	--self.change_btn_consume_bg_icon = self.change_btn_consume_bg:getChildByName("icon")
	--self.change_btn_consume_bg_label = self.change_btn_consume_bg:getChildByName("label")
	--
	--self.cancel_btn = self.seerpalace_change_panel_right_bottom_container:getChildByName("cancel_btn")
	--local cancel_btn_label = self.cancel_btn:getChildByName("label")
	--cancel_btn_label:setString(UI_TI18N(5013))
	--self.cancel_btn:setVisible(false)
	--
	--self.save_btn = self.seerpalace_change_panel_right_bottom_container:getChildByName("save_btn")
	--local save_btn_label = self.save_btn:getChildByName("label")
	--save_btn_label:setString(UI_TI18N(5014))
	--self.save_btn:setVisible(false)

	--local main_container = self.root_wnd:getChildByName("main_container")
    --self:playEnterAnimatianByObj(main_container , 1)
	--
	--self.close_btn = main_container:getChildByName("close_btn")
    --self.explain_btn = main_container:getChildByName("explain_btn")
    --self.btn_shop = main_container:getChildByName("btn_shop")
    --local btn_shop_label = self.btn_shop:getChildByName("label")
    --btn_shop_label:setString(TI18N("先知商店"))
	--
    --self.btn_gift = main_container:getChildByName("btn_gift")
    --local btn_gift_label = self.btn_gift:getChildByName("label")
	--btn_gift_label:setString(TI18N("石碑礼包"))
	--
	--self.btn_score_summons = main_container:getChildByName("btn_score_summons")
	--self.btn_score_summons_label = self.btn_score_summons:getChildByName("label")
	--self.btn_score_summon_Icon = self.btn_score_summons:getChildByName("icon")
    --local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_jifen)
    --if item_config then
    --    local res = PathTool.getItemRes(item_config.icon)
    --    loadSpriteTexture(self.btn_score_summon_Icon, res, LOADTEXT_TYPE)
    --end
	--local cur_num = self.role_vo.predict_point
	--self.btn_score_summons_label:setString(cur_num)
    --self.tips_label = main_container:getChildByName("tips_label")
    --self.tips_label:setString(TI18N("随机召唤4~5星英雄或其英雄碎片"))
	--
    --local res_layout = main_container:getChildByName("res_layout")
    --for i=1,3 do
    --	local score_bg = res_layout:getChildByName("score_bg_" .. i)
    --	if score_bg then
    --		local score_label = score_bg:getChildByName("score_label")
    --		local score_image = score_bg:getChildByName("score_image")
    --		local cur_num = 0
    --		if i == 1 then
    --			cur_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_ZhiHui)
    --			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_ZhiHui)
    --			if item_config then
    --				score_image:loadTexture(PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
    --			end
    --		elseif i == 2 then
    --			cur_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_XianZhi)
    --			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_XianZhi)
    --			if item_config then
    --				score_image:loadTexture(PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
    --			end
    --		elseif i == 3 then
    --			cur_num = self.role_vo.recruithigh_hero
    --			local item_config = Config.ItemData.data_get_data(SeerpalaceConst.Good_JieJing)
    --			if item_config then
    --				score_image:loadTexture(PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
    --			end
    --		end
    --		score_label:setString(cur_num)
    --		self.label_list[i] = score_label
    --	end
    --end
	--
    --local tab_container = main_container:getChildByName("tab_container")
	--
    --local tab_name_list = {
    --    [1] = TI18N("先知圣殿"),
    --    [2] = TI18N("英雄转换")
    --}
    --for i=1,2 do
    --    local tab_btn = tab_container:getChildByName("tab_btn_"..i)
    --    if tab_btn then
    --        local object = {}
    --        object.unselect_bg = tab_btn:getChildByName('unselect_bg')
    --        object.unselect_bg:setVisible(true)
    --        object.select_bg = tab_btn:getChildByName('select_bg')
    --        object.select_bg:setVisible(false)
    --        -- object.label:setTextColor(cc.c4b(0xcf, 0xb5, 0x93, 0xff))
    --        object.lable = tab_btn:getChildByName("title")
    --        object.lable:setString(tab_name_list[i])
    --        object.tab_btn = tab_btn
    --        object.index = i
    --        self.tab_list[i] = object
    --    end
    --end
	--
	--self.container = main_container:getChildByName("container")
	--
	---- 适配
	--local top_off = display.getTop(main_container)
    --local container_size = main_container:getContentSize()
	--
    --tab_container:setPositionY(top_off - 143)
    --self.tips_label:setPositionY(top_off - 190)
    --res_layout:setPositionY(top_off - 143)
    --self.explain_btn:setPositionY(top_off - 143)
    --
    --local tab_y = self.btn_shop:getPositionY()
    --self.btn_shop:setPositionY(top_off - (container_size.height - tab_y))
    --local tab_y = self.btn_gift:getPositionY()
	--self.btn_gift:setPositionY(top_off - (container_size.height - tab_y))
	--local tab_y = self.btn_score_summons:getPositionY()
	--self.btn_score_summons:setPositionY(top_off - (container_size.height - tab_y))
end

function SeerpalaceMainWindow:register_event(  )
	--self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
	--	if event_type == ccui.TouchEventType.ended then
	--		playButtonSound2()
	--		ExchangeController:getInstance():openExchangeMainView(true)
	--	end
	--end)
	--self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
	--	if event_type == ccui.TouchEventType.ended then
	--		playButtonSound2()
	--		VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
	--	end
	--end)
	--self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
	--	if event_type == ccui.TouchEventType.ended then
	--		playButtonSound2()
	--		local config = Config.ItemData.data_get_data(Config.ItemData.data_assets_label2id.hero_exp)
	--		if config then
	--			BackpackController:getInstance():openTipsSource(true, config)
	--		end
	--	end
	--end)

	--registerButtonEventListener(self.seerpalace_summon_title_explain_btn, function(param,sender, event_type)
	--	local config = Config.RecruitHighData.data_seerpalace_const.game_rule1
	--	TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition())
	--end ,true, 2)
	--registerButtonEventListener(self.seerpalace_change_title_explain_btn, function(param,sender, event_type)
	--	local config = Config.RecruitHighData.data_seerpalace_const.game_rule2
	--	TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition())
	--end ,true, 2)

	--registerButtonEventListener(self.close_btn, handler(self, self._onClickCloseBtn), nil, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.btn_shop, handler(self, self._onClickShopBtn), true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)
	--registerButtonEventListener(self.btn_gift, handler(self, self._onClickGiftBtn), true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)
	--registerButtonEventListener(self.btn_score_summons, handler(self, self._onScoreSummonBtn), true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)

	--for index = 1,5 do
	--	registerButtonEventListener(self.seerpalace_summon_panel_pos_list[index].check_btn, function(param,sender, event_type)
	--		controller:openSeerpalacePreviewWindow(true, index)
	--	end ,true, 2)
	--
	--	self.seerpalace_summon_panel_pos_list[index]:addTouchEventListener(function(sender, event_type)
	--		if not self.summon_select_card or self.summon_select_card.index ~= index then
	--			customClickAction_2(self.seerpalace_summon_panel_pos_list[index], event_type, 1.2)
	--			if event_type == ccui.TouchEventType.ended then
	--				playButtonSound2()
	--				self:_onClickSummonCard(self.seerpalace_summon_panel_pos_list[index])
	--			end
	--		end
	--	end)
	--end
	--registerButtonEventListener(self.seerpalace_summon_panel_summon_btn, handler(self, self._onClickSummonBtn), true)

    --registerButtonEventListener(self.explain_btn, function(param,sender, event_type)
    --    local config
    --    if self.tab_object.index == 1 then
    --        config = Config.RecruitHighData.data_seerpalace_const.game_rule1
    --    else
    --        config = Config.RecruitHighData.data_seerpalace_const.game_rule2
    --    end
    --    TipsManager:getInstance():showCommonTips(config.desc, sender:getTouchBeganPosition())
    --end ,true, 2)

	--for k, object in pairs(self.tab_list) do
	--	if object.tab_btn then
	--		object.tab_btn:addTouchEventListener(function(sender, event_type)
	--			if event_type == ccui.TouchEventType.ended then
	--				playTabButtonSound()
	--				self:changeSelectedTab(object.index)
	--			end
	--		end)
	--	end
    --end

	-- 初始化或者断线重连的时候会跑出这个更新事件的
	self:addGlobalEvent(BackpackEvent.GET_ALL_DATA, function(bag_code)
		self:updateTopNumWealth()
	end)
    -- 道具数量更新
    self:addGlobalEvent(BackpackEvent.ADD_GOODS, function(bag_code, data_list)
		--self:refreshGoodNums(bag_code, data_list)
		self:updateTopNumWealth()
	end)
	self:addGlobalEvent(BackpackEvent.DELETE_GOODS, function(bag_code, data_list)
		--self:refreshGoodNums(bag_code, data_list)
		self:updateTopNumWealth()
	end)
	self:addGlobalEvent(BackpackEvent.MODIFY_GOODS_NUM, function(bag_code, data_list)
		--self:refreshGoodNums(bag_code, data_list)
		self:updateTopNumWealth()
	end)
	

    -- 积分资产更新
    if self.role_vo ~= nil then
        if self.role_assets_event == nil then
            self.role_assets_event = self.role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if key == "recruithigh_hero" then
					self:updateTopNumWealth()
				elseif key == "predict_point" then
					--self.btn_score_summons_label:setString(value)
					self:updateTopNumWealth()
					self:updateBtnRed()
				elseif key == "vip_lev" then
					self:updateBtnRed()
                end
				if key == "coin" or key == "gold" or key == "red_gold" or key == "silver_coin" or key == "hero_exp" then
					self:updateTopNumWealth()
				elseif key == "lev" then 	--等级
					self:updataExchangeRedPoint()
				end
            end)
        end
    end
    -- VIP特权礼包
    self:addGlobalEvent(VipEvent.PRIVILEGE_INFO, function ( )
        self:initBtnGift()
    end)

	if not self.role_change_info_event  then
		self.role_change_info_event = GlobalEvent:getInstance():Bind(SeerpalaceEvent.Change_Role_Info_Event,function (data)
			self:setData(data)
		end)
	end

	if not self.change_success_event then
		self.change_success_event = GlobalEvent:getInstance():Bind(SeerpalaceEvent.Change_Role_Success,function ()
			--self:handleRightChangeEffect(true)
		end)
	end


	--registerButtonEventListener(self.change_btn, handler(self, self._onClickChangeBtn), true)
	--registerButtonEventListener(self.cancel_btn, handler(self, self._onClickCancelBtn), true)
	--registerButtonEventListener(self.save_btn, handler(self, self._onClickSaveBtn), true)
	--registerButtonEventListener(self.left_panel, handler(self, self._onClickLeftHero))
	--registerButtonEventListener(self.right_panel, handler(self, self._onClickRightHero))

	if not self.red_point_status_event then
		self.red_point_status_event = GlobalEvent:getInstance():Bind(SeerpalaceEvent.Red_Point_Status,function ()
			self:gw_updateSheet1Redpoint()
		end)
	end

	--点金红点
	if self.coin_touch_redpoint == nil then
		self.coin_touch_redpoint = GlobalEvent:getInstance():Bind(ExchangeEvent.Extra_Reward, function(data)
			self.exchange_data = data
			self:updataExchangeRedPoint()
		end)
	end
end

---- 道具数量刷新
--function SeerpalaceMainWindow:refreshGoodNums( bag_code, data_list )
--	if bag_code == BackPackConst.Bag_Code.BACKPACK then
--		for i,v in pairs(data_list) do
--			if v and v.base_id then
--				if v.base_id == SeerpalaceConst.Good_ZhiHui and self.label_list[2] then
--					local cur_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_ZhiHui)
--					self.label_list[1]:setString(cur_num)
--				elseif v.base_id == SeerpalaceConst.Good_XianZhi and self.label_list[3] then
--					local cur_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_XianZhi)
--					self.label_list[2]:setString(cur_num)
--				end
--			end
--		end
--	end
--end

---- 切换标签页
--function SeerpalaceMainWindow:changeSelectedTab( index )
--	if self.tab_object ~= nil and self.tab_object.index == index then return end
--	if index == SeerpalaceConst.Tab_Index.Summon then --先知召唤界面显示积分召唤其他不显示
--		self.btn_shop:setVisible(false)
--		self.btn_gift:setVisible(false)
--		self.btn_score_summons:setVisible(true)
--		self.seerpalace_summon_title:setVisible(true)
--		self.seerpalace_change_title:setVisible(false)
--		self.seerpalace_summon_panel:setVisible(true)
--		self.seerpalace_change_panel:setVisible(false)
--	else
--		self.btn_shop:setVisible(true)
--		self.btn_gift:setVisible(true)
--		self.btn_score_summons:setVisible(false)
--		self.seerpalace_summon_title:setVisible(false)
--		self.seerpalace_change_title:setVisible(true)
--		self.seerpalace_summon_panel:setVisible(false)
--		self.seerpalace_change_panel:setVisible(true)
--		SeerpalaceController:getInstance():requestSummonOpen()
--	end
--
--    if self.tab_object then
--        self.tab_object.select_bg:setVisible(false)
--        self.tab_object = nil
--    end
--    self.tab_object = self.tab_list[index]
--    if self.tab_object then
--        self.tab_object.select_bg:setVisible(true)
--    end
--
--	if index == SeerpalaceConst.Tab_Index.Summon then
--		--self.tips_label:setVisible(true)
--		self.background:loadTexture(PathTool.getPlistImgForDownLoad("gw_seerpalace","z_background_01",true), LOADTEXT_TYPE)
--
--		self:updateSummonBtnLabel()
--	elseif index == SeerpalaceConst.Tab_Index.Change then
--		if self.is_first_open then
--			-- 初次打开界面时请求置换相关数据
--			controller:requestSeerpalaceChangeInfo()
--			self.is_first_open = false
--		end
--		--self.tips_label:setVisible(false)
--		self.background:loadTexture(PathTool.getPlistImgForDownLoad("gw_seerpalace","z_background_02",true), LOADTEXT_TYPE)
--	end
--
--	--if self.select_panel then
--	--	self.select_panel:addToParent(false)
--	--	self.select_panel = nil
--	--end
--	--self.select_panel = self.panel_list[index]
--	--if self.select_panel == nil then
--	--	if index == SeerpalaceConst.Tab_Index.Summon then
--	--		self.select_panel = SeerpalaceSummonPanel.new()
--	--	elseif index == SeerpalaceConst.Tab_Index.Change then
--	--		self.select_panel = SeerpalaceChangePanel.new()
--	--	end
--	--	if self.select_panel then
--	--		self.container:addChild(self.select_panel)
--	--		self.panel_list[index] = self.select_panel
--	--	end
--	--end
--	--if self.select_panel then
--	--	self.select_panel:addToParent(true)
--	--end
--end
--点击页签
function SeerpalaceMainWindow:onClickSheetBtn(index)
	if self.gw_summon ~= nil and self.gw_summon == true then return end

	if self.sheet == index then
		return
	end

	self.sheet = index

	self:setSheetTypeUI()
end

--根据页签类型刷新页签
function SeerpalaceMainWindow:setSheetTypeUI()
	for i,v in pairs(self.sheet_btn_list) do
		v.normal:setVisible(true)
		v.select:setVisible(false)
		v.spine_flag = false
	end
	self.sheet_btn_list[self.sheet].normal:setVisible(false)
	self.sheet_btn_list[self.sheet].select:setVisible(true)

	self.sheet_btn_list[self.sheet].spine_flag = true
	self.sheet_btn_list[self.sheet].spine:setAnimation(0, "anniu_xuanzhong", false)

	self:update_seerpalace_summon_panel()
	self:update_seerpalace_change_panel()
	self:updateTopNumWealth()
end

function SeerpalaceMainWindow:update_seerpalace_summon_panel()
	if self.sheet ~= SeerpalaceConst.Tab_Index.Summon then
		self.score_summon_btn:setVisible(false)
		self.seerpalace_summon_panel:setVisible(false)
		return
	end

	if self.seerpalace_summon_panel.summon_btn == nil then
		self.seerpalace_summon_panel:setPositionY(display.getBottom())
		self.seerpalace_summon_panel.summon_btn = self.seerpalace_summon_panel:getChildByName("summon_btn")
		self.seerpalace_summon_panel.summon_btn:addTouchEventListener(function(sender, event_type)
			customClickAction_4(sender, event_type)
			if event_type == ccui.TouchEventType.ended then
				self:_onClickSummonBtn()
				--local time = 0.5
				--self.seerpalace_summon_panel:runAction(cc.Repeat:create(cc.Sequence:create(cc.DelayTime:create(time), cc.CallFunc:create(function() self:_onClickSummonBtn(); time = time + 0.5 end)), 50))
			end
		end)
		local node = self.seerpalace_summon_panel.summon_btn:getChildByName("label_node")
		self.seerpalace_summon_panel.summon_btn_label = createRichLabel(32, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0.5, 0.5), cc.p(0, 0), nil, nil, 268)
		node:addChild(self.seerpalace_summon_panel.summon_btn_label)
		local node = self.seerpalace_summon_panel:getChildByName("tips_node")
		self.seerpalace_summon_panel.tips_label = createRichLabel(28, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0.5, 0.5), cc.p(0, 0), nil, nil, 550)
		node:addChild(self.seerpalace_summon_panel.tips_label)
		self.seerpalace_summon_panel.tips_label:setString(UI_TI18N(5010))

		--先知召唤
		self.seerpalace_summon_panel_pos_list = {}
		for i=1,5 do
			local pos_root = self.seerpalace_summon_panel:getChildByName("pos_" .. i)
			self.seerpalace_summon_panel_pos_list[i] = pos_root
			local group_id = SeerpalaceConst.Index_To_GroupId[i]
			local config = Config.RecruitHighData.data_seerpalace_data[group_id]
			if config and config.item_once then
				self.seerpalace_summon_panel_pos_list[i].summon_cost = config.item_once[1] -- 召唤所需道具id和数量
				self.seerpalace_summon_panel_pos_list[i].group_id = group_id
			else
				Debug.log("找不到先知召唤配置（data_seerpalace_data）group_id："..group_id)
			end
			self.seerpalace_summon_panel_pos_list[i].index = i
			self.seerpalace_summon_panel_pos_list[i].spine_node = pos_root:getChildByName("spine_node")
			self.seerpalace_summon_panel_pos_list[i].check_btn = pos_root:getChildByName("check_btn")
			local action = "feng_luoxia"
			if i==1 then
				action = "sui_luoxia"
			elseif i==2 then
				action = "huo_luoxia"
			elseif i==3 then
				action = "feng_luoxia"
			elseif i==4 then
				action = "tu_luoxia"
			elseif i==5 then
				action = "guangan_luoxia"
			end
			self.seerpalace_summon_panel_pos_list[i].spine = gw_createEffectSpine("E90021", cc.p(0, 0), cc.p(0.5, 0.5), false, action)
			self.seerpalace_summon_panel_pos_list[i].spine_node:addChild(self.seerpalace_summon_panel_pos_list[i].spine)

			local function animationCompleteFunc(event)
				if event.animation == "sui_xuanzong" then
					self.seerpalace_summon_panel_pos_list[1].spine:setAnimation(0, "sui_xunhuan", true)
				elseif event.animation == "huo_xuanzong" then
					self.seerpalace_summon_panel_pos_list[2].spine:setAnimation(0, "huo_xunhuan", true)
				elseif event.animation == "feng_xuanzong" then
					self.seerpalace_summon_panel_pos_list[3].spine:setAnimation(0, "feng_xunhuan", true)
				elseif event.animation == "tu_xuanzong" then
					self.seerpalace_summon_panel_pos_list[4].spine:setAnimation(0, "tu_xunhuan", true)
				elseif event.animation == "guangan_xuanzong" then
					self.seerpalace_summon_panel_pos_list[5].spine:setAnimation(0, "guangan_xunhuan", true)
				end
			end
			self.seerpalace_summon_panel_pos_list[i].spine:registerSpineEventHandler(animationCompleteFunc, sp.EventType.ANIMATION_COMPLETE)

			--self.seerpalace_summon_panel_pos_list[i]:setOpacity(128)

			-- 引导需要
			self.seerpalace_summon_panel_pos_list[i]:setName("guide_card_" .. i)

			self.seerpalace_summon_panel_pos_list[i].check_btn:addTouchEventListener(function(sender, event_type)
				--customClickAction_4(sender, event_type)
				if event_type == ccui.TouchEventType.ended then
					controller:openSeerpalacePreviewWindow(true, i)
				end
			end)

			self.seerpalace_summon_panel_pos_list[i]:addTouchEventListener(function(sender, event_type)
				if not self.summon_select_card or self.summon_select_card.index ~= i then
					--customClickAction_2(self.seerpalace_summon_panel_pos_list[i], event_type, 1.2)
					if event_type == ccui.TouchEventType.ended then
						playButtonSound2()
						self:_onClickSummonCard(self.seerpalace_summon_panel_pos_list[i])
					end
				end
			end)
		end
		--self.seerpalace_summon_panel_summon_btn = self.seerpalace_summon_panel:getChildByName("summon_btn")
		--self.seerpalace_summon_panel_summon_btn_label = self.seerpalace_summon_panel_summon_btn:getChildByName("label")
		--self.seerpalace_summon_panel_summon_btn_label:setString(UI_TI18N(5011))
	end



	self:updateSummonBtnLabel()
	self.score_summon_btn:setVisible(true)
	self.seerpalace_summon_panel:setVisible(true)
end

function SeerpalaceMainWindow:update_seerpalace_change_panel()
	if self.sheet ~= SeerpalaceConst.Tab_Index.Change then
		self.seerpalace_change_panel:setVisible(false)
		return
	end

	if self.seerpalace_change_panel.left_info == nil then
		self.seerpalace_change_panel.left_info = self.seerpalace_change_panel:getChildByName("left_info")
		self.seerpalace_change_panel.left_info:setPositionX(display.getLeft())
		self.seerpalace_change_panel.left_info:setPositionY(display.getBottom())
		--英雄阵营
		local camp_node = self.seerpalace_change_panel.left_info:getChildByName("camp_node")
		self.seerpalace_change_panel.left_info.camp_node = camp_node
		self.seerpalace_change_panel.left_info.camp_node:setVisible(false)
		self.camp_btn_list = {}
		for index=0,6 do
			self.camp_btn_list[index] = camp_node:getChildByName("camp_btn"..index)
			if index == SeerpalaceConst.GW_Change_Index_Camp.Light or index == SeerpalaceConst.GW_Change_Index_Camp.Dark then
				self.camp_btn_list[index]:setVisible(false)
			else
				self.camp_btn_list[index]:addTouchEventListener(function(sender, event_type)
					if event_type == ccui.TouchEventType.ended then
						playButtonSound2()
						self:_onClickCampBtn(index)
					end
				end)
				--self.camp_btn_list[index].normal = self.camp_btn_list[index]:getChildByName("normal")
				self.camp_btn_list[index].select = self.camp_btn_list[index]:getChildByName("select")
				self.camp_btn_list[index].index = index
			end
		end

		self.hero_list_container = self.seerpalace_change_panel.left_info:getChildByName("list_container")
		self.hero_list_container_size = cc.size(display.width - 855, display.height - 168)
		self.hero_list_cover = self.seerpalace_change_panel.left_info:getChildByName("list_cover")

		self.seerpalace_change_panel.right_info = self.seerpalace_change_panel:getChildByName("right_info")
		self.seerpalace_change_panel.right_info:setPositionX(display.getRight())
		self.seerpalace_change_panel.right_info:setPositionY(display.getBottom())

		local left_role = self.seerpalace_change_panel.right_info:getChildByName("left_role")
		self.seerpalace_change_panel.right_info_left_role = left_role
		self.seerpalace_change_panel.right_info_left_role:setVisible(false)
		self.seerpalace_change_panel.right_info_left_role:addTouchEventListener(function(sender, event_type)
			--customClickAction_4(sender, event_type)
			if event_type == ccui.TouchEventType.ended then
				self:_onClickLeftHero()
			end
		end)
		self.seerpalace_change_panel.right_info_left_role.empty = left_role:getChildByName("empty")
		self.seerpalace_change_panel.right_info_left_role.spine_node = left_role:getChildByName("spine_node")
		local top_info = left_role:getChildByName("top_info")
		self.seerpalace_change_panel.right_info_left_role.top_info = top_info
		self.seerpalace_change_panel.right_info_left_role.top_info_name = top_info:getChildByName("name")
		self.seerpalace_change_panel.right_info_left_role.top_info_camp_type = top_info:getChildByName("camp_type")
		self.seerpalace_change_panel.right_info_left_role.top_info_star = top_info:getChildByName("star")
		self.seerpalace_change_panel.right_info_left_role.top_info_star_spine_node = top_info:getChildByName("star_spine_node")
		local bottom_info = left_role:getChildByName("bottom_info")
		self.seerpalace_change_panel.right_info_left_role.bottom_info = bottom_info
		self.seerpalace_change_panel.right_info_left_role.bottom_info_lev = bottom_info:getChildByName("lev")

		local right_role = self.seerpalace_change_panel.right_info:getChildByName("right_role")
		self.seerpalace_change_panel.right_info_right_role = right_role
		self.seerpalace_change_panel.right_info_right_role:setVisible(false)
		self.seerpalace_change_panel.right_info_right_role:addTouchEventListener(function(sender, event_type)
			--customClickAction_4(sender, event_type)
			if event_type == ccui.TouchEventType.ended then
				self:_onClickRightHero()
			end
		end)
		self.seerpalace_change_panel.right_info_right_role.rand_icon = right_role:getChildByName("rand_icon")
		self.seerpalace_change_panel.right_info_right_role.spine_node = right_role:getChildByName("spine_node")
		local top_info = right_role:getChildByName("top_info")
		self.seerpalace_change_panel.right_info_right_role.top_info = top_info
		self.seerpalace_change_panel.right_info_right_role.top_info_name = top_info:getChildByName("name")
		self.seerpalace_change_panel.right_info_right_role.top_info_camp_type = top_info:getChildByName("camp_type")
		self.seerpalace_change_panel.right_info_right_role.top_info_star = top_info:getChildByName("star")
		self.seerpalace_change_panel.right_info_right_role.top_info_star_spine_node = top_info:getChildByName("star_spine_node")
		local bottom_info = right_role:getChildByName("bottom_info")
		self.seerpalace_change_panel.right_info_right_role.bottom_info = bottom_info
		self.seerpalace_change_panel.right_info_right_role.bottom_info_lev = bottom_info:getChildByName("lev")

		self.seerpalace_change_panel.right_info_cancel_btn = self.seerpalace_change_panel.right_info:getChildByName("cancel_btn")
		self.seerpalace_change_panel.right_info_cancel_btn:setVisible(false)
		self.seerpalace_change_panel.right_info_cancel_btn:addTouchEventListener(function(sender, event_type)
			customClickAction_4(sender, event_type)
			if event_type == ccui.TouchEventType.ended then
				self:_onClickCancelBtn()
			end
		end)
		self.seerpalace_change_panel.right_info_cancel_btn_label = self.seerpalace_change_panel.right_info_cancel_btn:getChildByName("label")
		self.seerpalace_change_panel.right_info_cancel_btn_label:setString(UI_TI18N(5013))
		self.seerpalace_change_panel.right_info_save_btn = self.seerpalace_change_panel.right_info:getChildByName("save_btn")
		self.seerpalace_change_panel.right_info_save_btn:setVisible(false)
		self.seerpalace_change_panel.right_info_save_btn:addTouchEventListener(function(sender, event_type)
			customClickAction_4(sender, event_type)
			if event_type == ccui.TouchEventType.ended then
				self:_onClickSaveBtn()
			end
		end)
		self.seerpalace_change_panel.right_info_save_btn_label = self.seerpalace_change_panel.right_info_save_btn:getChildByName("label")
		self.seerpalace_change_panel.right_info_save_btn_label:setString(UI_TI18N(5014))
		self.seerpalace_change_panel.right_info_change_btn = self.seerpalace_change_panel.right_info:getChildByName("change_btn")
		self.seerpalace_change_panel.right_info_change_btn:setVisible(false)
		self.seerpalace_change_panel.right_info_change_btn:addTouchEventListener(function(sender, event_type)
			customClickAction_4(sender, event_type)
			if event_type == ccui.TouchEventType.ended then
				self:_onClickChangeBtn()
			end
		end)
		self.seerpalace_change_panel.right_info_change_btn_label = self.seerpalace_change_panel.right_info_change_btn:getChildByName("label")
		self.seerpalace_change_panel.right_info_change_btn_label:setString(UI_TI18N(5012))

		self.seerpalace_change_panel.right_info_change_consume_info = self.seerpalace_change_panel.right_info:getChildByName("change_consume_info")
		self.seerpalace_change_panel.right_info_change_consume_info:setVisible(false)
		self.seerpalace_change_panel.right_info_change_consume_info_bg = self.seerpalace_change_panel.right_info_change_consume_info:getChildByName("bg")
		local label_node = self.seerpalace_change_panel.right_info_change_consume_info:getChildByName("label_node")
		self.seerpalace_change_panel.right_info_change_consume_info_label = createRichLabel(24, cc.c4b(0xc4,0xd4,0xde,0xff), cc.p(0.5, 0.5), cc.p(0, 0), nil, nil, 800)
		label_node:addChild(self.seerpalace_change_panel.right_info_change_consume_info_label)
	end


	SeerpalaceController:getInstance():requestSummonOpen()
	if self.is_first_open then
		-- 初次打开界面时请求置换相关数据
		controller:requestSeerpalaceChangeInfo()
		self.is_first_open = false
	end

	self.seerpalace_change_panel:setVisible(true)
end

function SeerpalaceMainWindow:openRootWnd( index )
	ExchangeController:getInstance():send23606()
	self.cur_role_item = nil
	self.cur_camp_type = HeroConst.CampType.eNone
	self.is_first_open = true
	self.sheet = index or SeerpalaceConst.Tab_Index.Summon
	self:setSheetTypeUI()
	self:initBtnGift()
	self:updateBtnRed()
	self:gw_updateSheet1Redpoint()
end

function SeerpalaceMainWindow:updateBtnRed()
	local status = model:getScoreSummonRed()
	if status == true and self.score_summon_btn_redpoint_spine == nil then
		self.score_summon_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
		self.score_summon_btn_redpoint:addChild(self.score_summon_btn_redpoint_spine)
	end
	self.score_summon_btn_redpoint:setVisible(status)
end

function SeerpalaceMainWindow:initBtnGift()
    local id = 101 --先知礼包的id  一般不会改了.改了这里跳转也要跟着改 --by lwc
    local privilege = VipController:getInstance():getModel():getPrivilegeDataById(id)
	if privilege and privilege.status == 1 then
		--self.btn_score_summons:setPositionY(self.btn_gift:getPositionY())
		self.gift_btn:setVisible(false)
	else
		self.gift_btn:setVisible(true)
	end
end

-----------------@ 按钮点击事件
---- 关闭
--function SeerpalaceMainWindow:_onClickCloseBtn(  )
--	controller:openSeerpalaceMainWindow(false)
--end

---- 商店
--function SeerpalaceMainWindow:_onClickShopBtn(  )
--    controller:openSeerpalaceShopWindow(true)
--end

---- 商店
--function SeerpalaceMainWindow:_onClickGiftBtn(  )
--	JumpController:getInstance():jumpViewByEvtData({7, VIPTABCONST.PRIVILEGE})
--end

---- 积分召唤
--function SeerpalaceMainWindow:_onScoreSummonBtn(  )
--	controller:openSeerpalaceSummonScoreWindow(true)
--end

function SeerpalaceMainWindow:close_callback(  )

	if self.red_point_status_event then
		GlobalEvent:getInstance():UnBind(self.red_point_status_event)
		self.red_point_status_event = nil
	end
	--for k, panel in pairs(self.panel_list) do
    --    panel:DeleteMe()
    --end
    --self.panel_list = nil

	self.sheet = nil
    if self.role_vo ~= nil then
        if self.role_assets_event ~= nil then
            self.role_vo:UnBind(self.role_assets_event)
            self.role_assets_event = nil
        end
    end
	self.top_num_wealth_list = nil

	if self.background_load then
		self.background_load:DeleteMe()
		self.background_load = nil
	end

	if self.sheet_btn_list then
		for i,sheet in pairs(self.sheet_btn_list) do
			if sheet.red_point_spine ~= nil then
				sheet.red_point_spine:setVisible(false)
				sheet.red_point_spine:removeFromParent()
				sheet.red_point_spine = nil
			end
			if sheet.spine then
				sheet.spine:clearTracks()
				sheet.spine:removeFromParent()
				sheet.spine = nil
			end
		end
		self.sheet_btn_list = nil
	end

	if self.score_summon_btn_redpoint_spine ~= nil then
		self.score_summon_btn_redpoint_spine:setVisible(false)
		self.score_summon_btn_redpoint_spine:removeFromParent()
		self.score_summon_btn_redpoint_spine = nil
	end

	if self.left_role ~= nil then
		self.left_role:clearTracks()
		self.left_role:removeFromParent()
		self.left_role = nil
	end
	if self.right_role ~= nil then
		self.right_role:clearTracks()
		self.right_role:removeFromParent()
		self.right_role = nil
	end

	if self.role_change_info_event then
		GlobalEvent:getInstance():UnBind(self.role_change_info_event)
		self.role_change_info_event = nil
	end
	if self.change_success_event then
		GlobalEvent:getInstance():UnBind(self.change_success_event)
		self.change_success_event = nil
	end

	if self.seerpalace_summon_panel_pos_list ~= nil then
		for i,v in pairs(self.seerpalace_summon_panel_pos_list) do
			if v.spine ~= nil then
				v.spine:clearTracks()
				v.spine:removeFromParent()
				v.spine = nil
			end
		end

		self.seerpalace_summon_panel_pos_list = nil
	end

	if self.seerpalace_summon_panel_spine ~= nil then
		self.seerpalace_summon_panel_spine:clearTracks()
		self.seerpalace_summon_panel_spine:removeFromParent()
		self.seerpalace_summon_panel_spine = nil
	end

	self.exchange_data = nil
	if self.coin_redpoint_spine ~= nil then
		self.coin_redpoint_spine:clearTracks()
		self.coin_redpoint_spine:removeFromParent()
		self.coin_redpoint_spine = nil
	end
	if self.coin_touch_redpoint then
		GlobalEvent:getInstance():UnBind(self.coin_touch_redpoint)
		self.coin_touch_redpoint = nil
	end

    controller:openSeerpalaceMainWindow(false)
end

--刷新上方货币
function SeerpalaceMainWindow:updateTopNumWealth()
	if not self.top_num_wealth_list then return end

	if self.top_num_wealth_list[1] ~= nil then
		local key = "gold"
		local key_value = self.role_vo[key] or 0
		self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
		self.top_num_wealth_list[1].btn:setVisible(true)
	end
	if self.top_num_wealth_list[2] ~= nil then
		local key = "coin"
		local key_value = self.role_vo[key] or 0
		self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
		self.top_num_wealth_list[2].btn:setVisible(true)
	end
	if self.sheet == SeerpalaceConst.Tab_Index.Summon then
		if self.top_num_wealth_list[3] ~= nil then
			local num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_ZhiHui)
			self.top_num_wealth_list[3].value:setString(MoneyTool.GetMoneyString(num))
			self.top_num_wealth_list[3].btn:setVisible(true)
		end
		self.top_num_wealth_list[3].btn:setVisible(true)
	else
		self.top_num_wealth_list[3].btn:setVisible(false)
	end

	local num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(SeerpalaceConst.Good_XianZhi)
	self.cost_info_list[1].label:setString(MoneyTool.GetMoneyString(num))
	local num = self.role_vo.recruithigh_hero
	self.cost_info_list[2].label:setString(MoneyTool.GetMoneyString(num))
	local num = self.role_vo.predict_point
	self.score_summon_btn_label:setString(MoneyTool.GetMoneyString(num))
	self.score_summon_btn_label:setFontSize(26)
	if self.score_summon_btn_label:getContentSize().width > 150 then
		for k=1,15 do
			self.score_summon_btn_label:setFontSize(26-k)
			if self.score_summon_btn_label:getContentSize().width <= 150 then
				break
			end
		end
	end

end

--更新点金红点
function SeerpalaceMainWindow:updataExchangeRedPoint()
	if not self.exchange_data then
		return
	end
	local red_lev_min =  Config.ConvertData.data_trade_cost.red_lev_min
	for i,v in ipairs(self.exchange_data.list) do
		if v.id == 1 and self.coin_redpoint then
			local status = false
			if (v.max - v.num) > 0 and self.role_vo and red_lev_min and red_lev_min.val <= self.role_vo.lev then
				status = true
			end
			if status == true then
				if self.coin_redpoint_spine == nil then
					self.coin_redpoint_spine = PathTool.gw_createRedpointSpine()
					self.coin_redpoint_spine:setPosition(40,32)
					self.coin_redpoint:addChild(self.coin_redpoint_spine)
				end
				self.coin_redpoint_spine:setVisible(true)
				break
			else
				if self.coin_redpoint_spine then
					self.coin_redpoint_spine:setVisible(false)
				end
			end
		end
	end
end
-- 点击了卡牌
function SeerpalaceMainWindow:_onClickSummonCard( card )
	if self.gw_summon ~= nil and self.gw_summon == true then return end

	if not card then
		return
	end
	if self.summon_select_card then
		if self.summon_select_card.index == card.index then
			return
		end
		--self.summon_select_card:setOpacity(128)

		local action = "feng_luoxia"
		if self.summon_select_card.index==1 then
			action = "sui_luoxia"
		elseif self.summon_select_card.index==2 then
			action = "huo_luoxia"
		elseif self.summon_select_card.index==3 then
			action = "feng_luoxia"
		elseif self.summon_select_card.index==4 then
			action = "tu_luoxia"
		elseif self.summon_select_card.index==5 then
			action = "guangan_luoxia"
		end
		self.summon_select_card.spine:setAnimation(0, action, false)
	end

	self.summon_select_card = card
	--self.summon_select_card:setOpacity(255)

	local action = "feng_xuanzong"
	if self.summon_select_card.index==1 then
		action = "sui_xuanzong"
	elseif self.summon_select_card.index==2 then
		action = "huo_xuanzong"
	elseif self.summon_select_card.index==3 then
		action = "feng_xuanzong"
	elseif self.summon_select_card.index==4 then
		action = "tu_xuanzong"
	elseif self.summon_select_card.index==5 then
		action = "guangan_xuanzong"
	end
	self.summon_select_card.spine:setAnimation(0, action, false)
	self:updateSummonBtnLabel()
end
-- 刷新召唤按钮文字显示
function SeerpalaceMainWindow:updateSummonBtnLabel(  )
	if self.sheet == nil or self.sheet ~= SeerpalaceConst.Tab_Index.Summon then
		return--当前不在先知召唤页签则不刷新
	end
	if self.summon_select_card then
		local summon_cost = self.summon_select_card.summon_cost
		if summon_cost then
			local bid = summon_cost[1]
			local num = summon_cost[2]

			--self.seerpalace_summon_panel_summon_btn_consume_bg_label:setString(num)
			local item_config = Config.ItemData.data_get_data(bid)
			if item_config ~= nil then
				local cost_str = string.format("<img src='%s' scale=0.35 /><div fontcolor=#ffffff>%s</div>", PathTool.getItemRes(item_config.icon), num)
				self.seerpalace_summon_panel.summon_btn_label:setString(string.format("%s %s", cost_str, UI_TI18N(5011)))
			else
				self.seerpalace_summon_panel.summon_btn_label:setString(UI_TI18N(5011))
				Debug.error("找不到道具配置！！ID:"..bid)
			end
			--if item_config then
			--	loadSpriteTexture(self.seerpalace_summon_panel_summon_btn_consume_bg_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
			--else
			--	Debug.error("找不到先知召唤消耗道具配置！道具ID："..bid)
			--end

			--local label_width = self.seerpalace_summon_panel_summon_btn_label:getContentSize().width
			--local total_len = label_width + 10 + 88
			--self.seerpalace_summon_panel_summon_btn_label:setPositionX(121 - (total_len*0.5) + (label_width*0.5) + 5)
			--self.seerpalace_summon_panel_summon_btn_consume_bg:setPositionX(121 - (total_len*0.5) + label_width + 10)
			--self.seerpalace_summon_panel_summon_btn_consume_bg:setVisible(true)

		else
			self.seerpalace_summon_panel.summon_btn_label:setString(UI_TI18N(5011))
			--self.seerpalace_summon_panel_summon_btn_label:setPositionX(121)
			--self.seerpalace_summon_panel_summon_btn_consume_bg:setVisible(false)
		end
	else
		self.seerpalace_summon_panel.summon_btn_label:setString(UI_TI18N(5011))
		--self.seerpalace_summon_panel_summon_btn_label:setPositionX(121)
		--self.seerpalace_summon_panel_summon_btn_consume_bg:setVisible(false)
	end
end

-- 点击召唤
function SeerpalaceMainWindow:_onClickSummonBtn(  )
	if self.gw_summon ~= nil and self.gw_summon == true then return end

	if self.summon_select_card then
		local summon_cost = self.summon_select_card.summon_cost
		if summon_cost then
			local bid = summon_cost[1]
			local num = summon_cost[2]

			local have_num = BackpackController:getInstance():getModel():getItemNumByBid(bid)
			--local group_id = self.summon_select_card.group_id
			-- 背包物品足够则先播放召唤特效再请求召唤协议，不足则直接请求协议（弹出物品来源和提示）
			if have_num >= num then
				self.gw_summon = true
				local pos_x = 266
				if self.summon_select_card.index == 1 then
					pos_x = 266
				elseif self.summon_select_card.index == 2 then
					pos_x = 454
				elseif self.summon_select_card.index == 3 then
					pos_x = 830
				elseif self.summon_select_card.index == 4 then
					pos_x = 1018
				elseif self.summon_select_card.index == 5 then
					pos_x = 642
				end
				if self.seerpalace_summon_panel_spine == nil then
					self.seerpalace_summon_panel_spine = gw_createEffectSpine("E90020", cc.p(0, 0), cc.p(0.5, 0.5), false, "animation")
					local spine_node = self.seerpalace_summon_panel:getChildByName("spine_node")
					spine_node:addChild(self.seerpalace_summon_panel_spine)
					self.seerpalace_summon_panel_spine:setPositionX(pos_x)
					self.seerpalace_summon_panel_spine:setPositionY(0)

					local function animationCompleteFunc(event)
						local group_id = self.summon_select_card.group_id
						controller:requestSeerpalaceSummon(group_id)
						self.seerpalace_summon_panel_spine:setVisible(false)
						self.gw_summon = false
					end
					self.seerpalace_summon_panel_spine:registerSpineEventHandler(animationCompleteFunc, sp.EventType.ANIMATION_COMPLETE)
				else
					self.seerpalace_summon_panel_spine:setPositionX(pos_x)
					self.seerpalace_summon_panel_spine:setAnimation(0, "animation", false)
				end
				self.seerpalace_summon_panel_spine:setVisible(true)
			else
				RoleController:getInstance():rgp_hander12745({bid = bid})
			end
		end
	else
		message(UI_TI18N(5015))
	end
end


function SeerpalaceMainWindow:_onClickCampBtn( index, force )
	if self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Light then
		return
	end
	if self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Dark then
		return
	end

	if self.cur_index == index and not force then return end

	if self.cur_index then
		self.camp_btn_list[self.cur_index].select:setVisible(false)
		--if self.cur_index == 0 then
		--	self.camp_btn_list[self.cur_index].normal:setVisible(true)
		--end
	end

	self.camp_btn_list[index].select:setVisible(true)
	--if index == 0 then
	--	self.camp_btn_list[index].normal:setVisible(false)
	--end

	self.cur_index = index
	self:refreshRoleList()
end

function SeerpalaceMainWindow:setData( data )
	self.data = data or {}
	--Debug.info(self.data)
	self.change_partner_id = data.partner_id or 0
	self.change_new_partner_bid = data.new_partner_bid or 0
	self.lock_partner_ids = data.partner_ids or {}

	--self.role_layout:setVisible(self.change_partner_id == 0)
	self.seerpalace_change_panel.right_info_cancel_btn:setVisible(self.change_partner_id ~= 0)
	self.seerpalace_change_panel.right_info_save_btn:setVisible(self.change_partner_id ~= 0)

	for k,cur_camp_data in pairs(self.camp_btn_list) do
		if cur_camp_data then
			--cur_camp_data.normal:setVisible(true)
			if cur_camp_data.select ~= nil then
				cur_camp_data.select:setVisible(false)
			end
		end
	end

	self.cur_role_vo = {}
	if self.change_partner_id == 0 then
		self.cur_index = self.cur_index or 0
		self:_onClickCampBtn(self.cur_index, true)
	else
		self.cur_camp_type = HeroConst.CampType.eNone
		if self.cur_role_item then
			self.cur_role_item:setSelected(false)
			self.cur_role_item = nil
		end
	end

	self:refreshRoleSpine()
end

-- 刷新英雄头像列表
function SeerpalaceMainWindow:refreshRoleList(  )
	self.cur_role_data = {}
	local all_role_list = HeroController:getInstance():getModel():getAllHeroArray()
	local camp_type = HeroConst.CampType.eNone
	if self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.All then
		camp_type = HeroConst.CampType.eNone
	elseif self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Water then
		camp_type = HeroConst.CampType.eWater
	elseif self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Fire then
		camp_type = HeroConst.CampType.eFire
	elseif self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Wind then
		camp_type = HeroConst.CampType.eWind
	--elseif self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Light then
	--	camp_type = HeroConst.CampType.eLight
	--elseif self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Dark then
	--	camp_type = HeroConst.CampType.eDark
	elseif self.cur_index == SeerpalaceConst.GW_Change_Index_Camp.Soil then
		camp_type = HeroConst.CampType.eSoil
	end
	self.cur_camp_type = camp_type

	for k,role_vo in pairs(all_role_list.items or {}) do
		if role_vo.star == 4 or role_vo.star == 5 then
			local is_lock = self:checkIsLockedRole(role_vo.id)
			if camp_type == HeroConst.CampType.eNone then
				if role_vo.camp_type == HeroConst.CampType.eWater or
						role_vo.camp_type == HeroConst.CampType.eFire or
						role_vo.camp_type == HeroConst.CampType.eWind or
						--role_vo.camp_type == HeroConst.CampType.eLight or
						--role_vo.camp_type == HeroConst.CampType.eDark or
						role_vo.camp_type == HeroConst.CampType.eSoil then
					local role_data = deepCopy(role_vo)
					role_data.is_locked = is_lock
					table_insert(self.cur_role_data, role_data)
				end
			elseif role_vo.camp_type == camp_type then
				local role_data = deepCopy(role_vo)
				role_data.is_locked = is_lock
				table_insert(self.cur_role_data, role_data)
			end
		end
	end

	local function SortFunc( objA, objB )
		local is_lock_a = self:checkIsLockedRole(objA.id)
		local is_lock_b = self:checkIsLockedRole(objB.id)
		if is_lock_a and not is_lock_b then
			return false
		elseif not is_lock_a and is_lock_b then
			return true
		elseif objA.star == objB.star then
			if objA.camp_type == objB.camp_type then
				return objA.lev > objB.lev
			else
				return objA.camp_type < objB.camp_type
			end
		else
			return objA.star > objB.star
		end
	end
	table_sort(self.cur_role_data, SortFunc)

	if self.cur_role_item then
		self.cur_role_item:setSelected(false)
	end

	local extendData = {scale = 0.92, can_click = true, from_type = HeroConst.ExhibitionItemType.eHeroChange}

	if self.role_scrollview == nil then
		local role_scrollview_col = 3 + math.floor((self.hero_list_container_size.width - 425)/133)
		local scale = 0.92
		local setting = {
			item_class = GW_HeroTempleSacrificeInfoListItem,      -- 单元类
			start_x = 33,                  -- 第一个单元的X起点
			space_x = 13,                    -- x方向的间隔
			start_y = 28,                    -- 第一个单元的Y起点
			space_y = 13,                   -- y方向的间隔
			item_width = GW_HeroTempleSacrificeInfoListItem.Width*scale,               -- 单元的尺寸width
			item_height = GW_HeroTempleSacrificeInfoListItem.Height*scale,              -- 单元的尺寸height
			row = 0,                        -- 行数，作用于水平滚动类型
			col = role_scrollview_col,		-- 列数，作用于垂直滚动类型
			scale = scale,
		}

		self.role_scrollview = CommonScrollViewLayout.new(self.hero_list_container, cc.p(0,0) , ScrollViewDir.vertical, ScrollViewStartPos.top, self.hero_list_container_size, setting)
		self.role_scrollview:setSwallowTouches(false)

		self.hero_list_cover:setContentSize(cc.size(89, 401 + (role_scrollview_col - 3) * 133))
	end

	self.role_scrollview:setData(self.cur_role_data, handler(self, self._onClickPartner), nil, extendData)
	self.role_scrollview:addEndCallBack(function (  )
		if self.cur_role_vo and next(self.cur_role_vo) ~= nil and self.cur_camp_type then
			-- 记录了上一次选中英雄的数据，切换到全部或该英雄阵营时，该英雄继续为选中状态
			if self.cur_role_vo.camp_type == self.cur_camp_type or self.cur_camp_type == HeroConst.CampType.eNone then
				local list = self.role_scrollview:getItemList()
				for k,v in pairs(list) do
					local data = v:getData()
					if data.id == self.cur_role_vo.id then
						self:_onClickPartner(v, data)
						break
					end
				end
			end
		elseif self.cancel_partner_id and self.cancel_partner_id ~= 0 then --选中取消置换的英雄
			local list = self.role_scrollview:getItemList()
			for k,v in pairs(list) do
				local data = v:getData()
				if data.id == self.cancel_partner_id then
					self:_onClickPartner(v, data)
					self.role_scrollview:jumpToMove(cc.p(-(k-3)*(0.85*119+15), 0), 0.01)
					break
				end
			end
			self.cancel_partner_id = 0
		end
	end)
end

-- 判断是否为锁住的英雄
function SeerpalaceMainWindow:checkIsLockedRole( id )
	local is_locked = false
	for k,v in pairs(self.lock_partner_ids) do
		if v.id and v.id == id then
			is_locked = true
			break
		end
	end
	return is_locked
end
function SeerpalaceMainWindow:_onClickPartner( item, vo )
	if vo:checkHeroLockTips(true) then
		return
	end
	if self.cur_role_item then
		self.cur_role_item:setSelected(false)
	end
	item:setSelected(true)
	self.cur_role_item = item
	self.cur_role_vo = vo

	local role_star = vo.star
	--local label_str = ""
	local cost_config = Config.RecruitHighData.data_seerpalace_const["hero_change" .. role_star]
	if cost_config and cost_config.val then
		local bid = cost_config.val[1][1]
		local num = cost_config.val[1][2]
		local item_config = Config.ItemData.data_get_data(bid)
		--self.change_btn_consume_bg_label:setString(num)
		--if item_config then
		--	loadSpriteTexture(self.change_btn_consume_bg_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
		--end
		--local label_width = self.change_btn_label:getContentSize().width
		--local total_len = label_width + 10 + 88
		--self.change_btn_label:setPositionX(121 - (total_len*0.5) + (label_width*0.5) + 5)
		--self.change_btn_consume_bg:setPositionX(121 - (total_len*0.5) + label_width + 10)
		--self.change_btn_consume_bg:setVisible(true)
		local str = ""
		if item_config ~= nil then
			local cost_str = string.format("<img src='%s' scale=0.3 /><div fontcolor=#e0e9ee fontsize=28>%d</div>", PathTool.getItemRes(item_config.icon), num)
			str = string.format("<div fontcolor=#c4d4de fontsize=24>%s</div> %s", UI_TI18N(5018), cost_str)
		else
			Debug.error("找不到道具配置！！ID:"..bid)
		end
		self.seerpalace_change_panel.right_info_change_consume_info_label:setString(str)

		self.seerpalace_change_panel.right_info_change_consume_info_bg:setVisible(true)
		self.seerpalace_change_panel.right_info_change_consume_info_label:setVisible(true)
	else
		self.seerpalace_change_panel.right_info_change_consume_info_bg:setVisible(false)
		self.seerpalace_change_panel.right_info_change_consume_info_label:setVisible(false)
	end

	self:refreshRoleSpine()
end
-- 刷新英雄模型显示
function SeerpalaceMainWindow:refreshRoleSpine(  )
	if self.right_role ~= nil then
		self.right_role:clearTracks()
		self.right_role:removeFromParent()
		self.right_role = nil
	end

	-- 选中了某一个英雄或者有未保存的重置英雄
	if (self.cur_role_vo and next(self.cur_role_vo) ~= nil) or self.change_partner_id ~= 0 then
		local left_role_vo = {} -- 左侧英雄的数据
		if self.change_partner_id == 0 then
			left_role_vo = self.cur_role_vo
			self.seerpalace_change_panel.right_info_change_btn:setVisible(true)
			self.seerpalace_change_panel.right_info_change_consume_info:setVisible(true)
			--self.change_btn:setVisible(true)
			self:handleRightRandomEffect(true)
		else
			left_role_vo = HeroController:getInstance():getModel():getHeroById(self.change_partner_id)
			self.seerpalace_change_panel.right_info_change_btn:setVisible(false)
			self.seerpalace_change_panel.right_info_change_consume_info:setVisible(false)
			--self.change_btn:setVisible(false)
			self:handleRightRandomEffect(false)
		end

		if self.change_new_partner_bid ~= 0 then
			self.seerpalace_change_panel.left_info.camp_node:setVisible(false)
			self.hero_list_container:setVisible(false)
			self.hero_list_cover:setVisible(false)
		else
			self.seerpalace_change_panel.left_info.camp_node:setVisible(true)
			self.hero_list_container:setVisible(true)
			self.hero_list_cover:setVisible(true)
			if self.seerpalace_change_panel.left_info.camp_node:isVisible() ~= true then
				self.seerpalace_change_panel.left_info.camp_node:setOpacity(0)
				self.seerpalace_change_panel.left_info.camp_node:runAction(cc.FadeIn:create(0.2))
				self.hero_list_container:setOpacity(0)
				self.hero_list_container:runAction(cc.FadeIn:create(0.2))
				self.hero_list_cover:setOpacity(0)
				self.hero_list_cover:runAction(cc.FadeIn:create(0.2))
			end
		end

		if left_role_vo and next(left_role_vo) ~= nil then
			self.cur_role_vo = left_role_vo
			local type_res = PathTool.gw_getCampTypeCommon01ForType3(left_role_vo.camp_type)
			if not self.left_role_bid or not self.left_role_star or self.left_role_bid ~= left_role_vo.bid or self.left_role_star ~= left_role_vo.star then
				self.left_role_bid = left_role_vo.bid
				self.left_role_star = left_role_vo.star
				local key = getNorKey(self.left_role_bid, self.left_role_star)
				local star_config = Config.PartnerData.data_partner_star(key)

				if self.left_role ~= nil then
					self.left_role:clearTracks()
					self.left_role:removeFromParent()
					self.left_role = nil
				end

				self.left_role = gw_createEffectSpine(star_config.res_id, cc.p(0, 0), cc.p(0.5, 0.5), true, PlayerAction.gw_idle)
				if star_config.skin ~= nil and star_config.skin ~= "" then
					setSpineSkin(self.left_role, star_config.skin)
				end
				self.seerpalace_change_panel.right_info_left_role.spine_node:addChild(self.left_role)
				local spine_scale = 1
				local offset_x = 0
				local offset_y = 0
				local spine_scale_config = Config.PartnerData.data_model_scale_offset_fun(left_role_vo.bid)
				if spine_scale_config then
					spine_scale = spine_scale_config.partner_change_scale/1000
					offset_x = spine_scale_config.partner_change_coordinate[1]
					offset_y = spine_scale_config.partner_change_coordinate[2]
				end
				self.left_role:setPosition(cc.p(0+offset_x,0+offset_y))
				self.left_role:setScale(spine_scale)
				--local action1 = cc.FadeOut:create(0.2)
				--local action2 = cc.FadeIn:create(0.2)
				--self.left_role:runAction(cc.Sequence:create(action1,action2))
				self.left_role:setOpacity(0)
				self.left_role:runAction(cc.FadeIn:create(0.2))

				--local spine_scale = 1
				--local offset_x = 0
				--local offset_y = 0
				--local spine_scale_config = Config.PartnerData.data_model_scale_offset_fun(left_role_vo.bid)
				--if spine_scale_config then
				--	spine_scale = spine_scale_config.partner_change_scale/1000
				--	offset_x = spine_scale_config.partner_change_coordinate[1]
				--	offset_y = spine_scale_config.partner_change_coordinate[2]
				--end
				--self.left_role = BaseRole.new(BaseRole.type.partner, left_role_vo, nil, {scale = spine_scale, skin_id = left_role_vo.use_skin})
				--self.left_role:setCascade(true)
				--self.left_role:setAnchorPoint(cc.p(0.5, 0))
				--self.left_role:setPosition(cc.p(0+offset_x, 0+offset_y))
				--self.left_role:setAnimation(0,PlayerAction.gw_idle,true)
				--self.seerpalace_change_panel.right_info_left_role.spine_node:addChild(self.left_role)

				self.seerpalace_change_panel.right_info_left_role.top_info_name:setString(left_role_vo.name)
				self.seerpalace_change_panel.right_info_left_role.bottom_info_lev:setString("Lv."..left_role_vo.lev)
				loadSpriteTexture(self.seerpalace_change_panel.right_info_left_role.top_info_camp_type, type_res, LOADTEXT_TYPE_PLIST)
				--if not self.left_name_label then
				--	self.left_name_label = createRichLabel(20, 1, cc.p(0.5, 0.5), cc.p(100, 372))
				--	self.left_panel:addChild(self.left_name_label)
				--end
				--local left_name = string.format("<img src='%s' scale=0.5 />    <div fontcolor=#ffffff outline=2,#000000>    %s</div>", type_res, left_role_vo.name)
				--self.left_name_label:setString(left_name)
				--self.left_lv_label:setString(left_role_vo.lev)
			end

			self.seerpalace_change_panel.right_info_right_role.bottom_info_lev:setString("Lv."..left_role_vo.lev)
			--self.right_lv_label:setString(left_role_vo.lev)
			local right_name = ""
			if self.change_new_partner_bid ~= 0 then
				local base_config = Config.PartnerData.data_partner_base[self.change_new_partner_bid]

				local key = getNorKey(self.change_new_partner_bid, self.left_role_star)
				local star_config = Config.PartnerData.data_partner_star(key)

				if self.right_role ~= nil then
					self.right_role:clearTracks()
					self.right_role:removeFromParent()
					self.right_role = nil
				end

				self.right_role = gw_createEffectSpine(star_config.res_id, cc.p(0, 0), cc.p(0.5, 0.5), true, PlayerAction.gw_idle)
				if star_config.skin ~= nil and star_config.skin ~= "" then
					setSpineSkin(self.right_role, star_config.skin)
				end
				self.seerpalace_change_panel.right_info_right_role.spine_node:addChild(self.right_role)
				local spine_scale = 1
				local offset_x = 0
				local offset_y = 0
				local spine_scale_config = Config.PartnerData.data_model_scale_offset_fun(self.change_new_partner_bid)
				if spine_scale_config then
					spine_scale = spine_scale_config.partner_change_scale/1000
					offset_x = spine_scale_config.partner_change_coordinate[1]
					offset_y = spine_scale_config.partner_change_coordinate[2]
				end
				self.right_role:setPosition(cc.p(0+offset_x,0+offset_y))
				self.right_role:setScale(spine_scale)
				--local action1 = cc.FadeOut:create(0.2)
				--local action2 = cc.FadeIn:create(0.2)
				--self.right_role:runAction(cc.Sequence:create(action1,action2))
				self.right_role:setOpacity(0)
				self.right_role:runAction(cc.FadeIn:create(0.2))

				--local spine_scale = 1
				--local offset_x = 0
				--local offset_y = 0
				--local spine_scale_config = Config.PartnerData.data_model_scale_offset_fun(self.change_new_partner_bid)
				--if spine_scale_config then
				--	spine_scale = spine_scale_config.partner_change_scale/1000
				--	offset_x = spine_scale_config.partner_change_coordinate[1]
				--	offset_y = spine_scale_config.partner_change_coordinate[2]
				--end
				--
				--local right_role_data = {bid = self.change_new_partner_bid, star = left_role_vo.star}
				--self.right_role = BaseRole.new(BaseRole.type.partner, right_role_data, nil, {scale = spine_scale})
				--self.right_role:setCascade(true)
				--self.right_role:setAnchorPoint(cc.p(0.5, 0))
				--self.right_role:setPosition(cc.p(0, 0))
				--self.right_role:setAnimation(0,PlayerAction.gw_idle,true)
				--self.seerpalace_change_panel.right_info_right_role.spine_node:addChild(self.right_role)

				if base_config and base_config.name then
					right_name = base_config.name
					--right_name = string.format("<img src='%s' scale=0.5 /><div fontcolor=#ffffff outline=2,#000000>    %s</div>", type_res, base_config.name)
				end
				self.seerpalace_change_panel.right_info_right_role.spine_node:setVisible(true)
			else
				right_name = UI_TI18N(5016)
				--right_name = string.format("<img src='%s' scale=0.5 /><div fontcolor=#ffffff outline=2,#000000>    ????</div>", type_res)
				self.seerpalace_change_panel.right_info_right_role.spine_node:setVisible(false)
			end
			loadSpriteTexture(self.seerpalace_change_panel.right_info_right_role.top_info_camp_type, type_res, LOADTEXT_TYPE_PLIST)
			self.seerpalace_change_panel.right_info_right_role.top_info_name:setString(right_name)
			--if not self.right_name_label then
			--	self.right_name_label = createRichLabel(20, 1, cc.p(0.5, 0.5), cc.p(100, 372))
			--	self.right_panel:addChild(self.right_name_label)
			--end
			--self.right_name_label:setString(right_name)
			--

			--for i,star in pairs(self.left_info_panel_star_list) do
			--	star:setVisible(i<=left_role_vo.star)
			--end
			--for i,star in pairs(self.right_info_panel_star_list) do
			--	star:setVisible(i<=left_role_vo.star)
			--end
			--for k,star in pairs(self.left_stars_1) do
			--	star:setVisible(false)
			--end
			--for k,star in pairs(self.left_stars_2) do
			--	star:setVisible(false)
			--end
			--for k,star in pairs(self.right_stars_1) do
			--	star:setVisible(false)
			--end
			--for k,star in pairs(self.right_stars_2) do
			--	star:setVisible(false)
			--end
			--if self.left_star10 then
			--	self.left_star10:setVisible(false)
			--end
			--if self.right_star10 then
			--	self.right_star10:setVisible(false)
			--end
			--
			--local role_star = left_role_vo.star
			--local _cStar = function(star_count, res, star_list, parent_node)
			--	local star_pos = SeerpalaceConst.Change_Pos_X[star_count] or {}
			--	for i=1,star_count do
			--		if not star_list[i] then
			--			local star = createImage(parent_node, res, 0, 338, cc.p(0.5, 0.5), true)
			--			star_list[i] = star
			--		end
			--		star_list[i]:setVisible(true)
			--		local pos_x = star_pos[i]
			--		if pos_x then
			--			star_list[i]:setPositionX(pos_x)
			--		end
			--	end
			--end
			--
			--if role_star > 0 and role_star <= 5 then
			--	local res = PathTool.getResFrame("common","common_90074")
			--	_cStar(role_star, res, self.left_stars_1, self.left_panel)
			--	_cStar(role_star, res, self.right_stars_1, self.right_panel)
			--elseif role_star >= 6 and role_star <= 9 then
			--	local res = PathTool.getResFrame("common","common_90075")
			--	local count = role_star - 5
			--	_cStar(count, res, self.left_stars_2, self.left_panel)
			--	_cStar(count, res, self.right_stars_2, self.right_panel)
			--elseif role_star >= 10 then
			--	local res = PathTool.getResFrame("common","common_90073")
			--	if self.left_star10 == nil then
			--		self.left_star10 = createImage(self.left_panel, res, 100, 338,cc.p(0.5,0.5),true,0,false)
			--		self.left_star10:setScale(1.2)
			--	else
			--		self.left_star10:setVisible(true)
			--	end
			--	if self.right_star10 == nil then
			--		self.right_star10 = createImage(self.right_panel, res, 100, 338,cc.p(0.5,0.5),true,0,false)
			--		self.right_star10:setScale(1.2)
			--	else
			--		self.right_star10:setVisible(true)
			--	end
			--end
			PathTool.gw_showStar(left_role_vo.star, self.seerpalace_change_panel.right_info_left_role.top_info_star, self.seerpalace_change_panel.right_info_left_role.top_info_star_spine, self.seerpalace_change_panel.right_info_left_role.top_info_star_spine_node)
			PathTool.gw_showStar(left_role_vo.star, self.seerpalace_change_panel.right_info_right_role.top_info_star, self.seerpalace_change_panel.right_info_right_role.top_info_star_spine, self.seerpalace_change_panel.right_info_right_role.top_info_star_spine_node)
		end

		--self.left_info_panel_spine_node:setVisible(true)
		--self.left_info_panel_lev_bg:setVisible(true)
		--self.left_info_panel_camp_type:setVisible(true)
		--self.left_info_panel_name:setVisible(true)
		--self.left_info_panel_star_con:setVisible(true)
		--self.right_info_panel_spine_node:setVisible(true)
		--self.right_info_panel_lev_bg:setVisible(true)
		--self.right_info_panel_camp_type:setVisible(true)
		--self.right_info_panel_name:setVisible(true)
		--self.right_info_panel_star_con:setVisible(true)


		self.seerpalace_change_panel.right_info_left_role.spine_node:setVisible(true)
		self.seerpalace_change_panel.right_info_left_role.top_info:setVisible(true)
		self.seerpalace_change_panel.right_info_left_role.bottom_info:setVisible(true)

		self.seerpalace_change_panel.right_info_right_role.top_info:setVisible(true)
		self.seerpalace_change_panel.right_info_right_role.bottom_info:setVisible(true)

		self:handleLeftEmptyEffect(false)
	else
		self.seerpalace_change_panel.left_info.camp_node:setVisible(true)
		self.hero_list_container:setVisible(true)
		self.hero_list_cover:setVisible(true)
		if self.seerpalace_change_panel.left_info.camp_node:isVisible() ~= true then
			self.seerpalace_change_panel.left_info.camp_node:setOpacity(0)
			self.seerpalace_change_panel.left_info.camp_node:runAction(cc.FadeIn:create(0.2))
			self.hero_list_container:setOpacity(0)
			self.hero_list_container:runAction(cc.FadeIn:create(0.2))
			self.hero_list_cover:setOpacity(0)
			self.hero_list_cover:runAction(cc.FadeIn:create(0.2))
		end

		self.seerpalace_change_panel.right_info_change_btn:setVisible(false)
		self.seerpalace_change_panel.right_info_change_consume_info:setVisible(false)
		self:handleLeftEmptyEffect(true)
		self:handleRightRandomEffect(false)
		self.left_role_bid = nil
		self.left_role_star = nil

		if self.left_role ~= nil then
			self.left_role:clearTracks()
			self.left_role:removeFromParent()
			self.left_role = nil
		end
		if self.right_role ~= nil then
			self.right_role:clearTracks()
			self.right_role:removeFromParent()
			self.right_role = nil
		end

		self.seerpalace_change_panel.right_info_left_role.spine_node:setVisible(false)
		self.seerpalace_change_panel.right_info_left_role.top_info:setVisible(false)
		self.seerpalace_change_panel.right_info_left_role.bottom_info:setVisible(false)

		self.seerpalace_change_panel.right_info_right_role.spine_node:setVisible(false)
		self.seerpalace_change_panel.right_info_right_role.top_info:setVisible(false)
		self.seerpalace_change_panel.right_info_right_role.bottom_info:setVisible(false)

	end

	self.seerpalace_change_panel.right_info_left_role:setVisible(true)
	self.seerpalace_change_panel.right_info_right_role:setVisible(true)
end

-- 左边为空时播放的特效
function SeerpalaceMainWindow:handleLeftEmptyEffect( status )
	if status == false then
		self.seerpalace_change_panel.right_info_left_role.empty:setVisible(false)
	else
		self.seerpalace_change_panel.right_info_left_role.empty:setVisible(true)
	end
end

-- 右边为随机时的特效
function SeerpalaceMainWindow:handleRightRandomEffect( status )
	if status == false then
		self.seerpalace_change_panel.right_info_right_role.rand_icon:setVisible(false)
	else
		self.seerpalace_change_panel.right_info_right_role.rand_icon:setVisible(true)
	end
end

-- 置换
function SeerpalaceMainWindow:_onClickChangeBtn(  )
	if self.cur_role_vo and self.cur_role_vo.id then
		controller:requestSeerpalaceChangeRole(self.cur_role_vo.id, 1)
	else
		message(UI_TI18N(5017))
	end
end

-- 取消
function SeerpalaceMainWindow:_onClickCancelBtn(  )
	if self.change_partner_id and self.change_partner_id ~= 0 then
		self.cancel_partner_id = self.change_partner_id
		controller:requestSeerpalaceChangeRole(self.change_partner_id, 0)
	end
end

-- 保存
function SeerpalaceMainWindow:_onClickSaveBtn()
	if self.change_partner_id and self.change_partner_id ~= 0 then
		controller:requestSeerpalaceChangeRole(self.change_partner_id, 2)
	end
end

function SeerpalaceMainWindow:_onClickLeftHero(  )
	if self.cur_role_vo and next(self.cur_role_vo) ~= nil then
		HeroController:getInstance():openHeroTipsPanel(true, self.cur_role_vo)
	end
end

function SeerpalaceMainWindow:_onClickRightHero(  )
	if self.change_new_partner_bid then
		HeroController:getInstance():openHeroTipsPanelByBid(self.change_new_partner_bid, self.cur_role_vo.lev)
		--HeroController:getInstance():openHeroTipsPanel(true, hero_vo)
	end
end

function SeerpalaceMainWindow:gw_updateSheet1Redpoint()
	local status = model:getScoreSummonRed()
	if status == false then
		--检测是否能进行先知召唤
		for i=1,5 do
			local group_id = SeerpalaceConst.Index_To_GroupId[i]
			local config = Config.RecruitHighData.data_seerpalace_data[group_id]
			if config and config.item_once then
				local item_id = config.item_once[1][1]
				local item_num = config.item_once[1][2]
				local have_num = BackpackController:getInstance():getModel():getItemNumByBid(item_id)
				if have_num >= item_num then
					status = true
					break
				end
			else
				Debug.log("找不到先知召唤配置（data_seerpalace_data）group_id："..group_id)
			end
		end
	end

	if status == true and self.sheet_btn_list[1].red_point_spine == nil then
		self.sheet_btn_list[1].red_point_spine = PathTool.gw_createRedpointSpine()
		self.sheet_btn_list[1].red_point:addChild(self.sheet_btn_list[1].red_point_spine)
	end
	self.sheet_btn_list[1].red_point:setVisible(status)
end
